<?php
/**
 *
 * @category        admin
 * @package         media
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: setparameter.php 66 2018-09-17 15:48:07Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/admin/media/setparameter.php $
 * @lastmodified    $Date: 2018-09-17 17:48:07 +0200 (Mo, 17. Sep 2018) $
 *
 */
if (!defined( 'SYSTEM_RUN' )){ require( dirname(dirname((__DIR__))).'/config.php' ); }
$admin = new admin('Media', 'media', false);
// Include the WB functions file
if (!function_exists('check_media_path')){require(WB_PATH.'/framework/functions.php');}

// check if theme language file exists for the language set by the user (e.g. DE, EN)
if(file_exists(THEME_PATH .'/languages/EN.php')) {require(THEME_PATH .'/languages/EN.php');}
if(file_exists(THEME_PATH .'/languages/'.LANGUAGE .'.php')) {require(THEME_PATH .'/languages/'.LANGUAGE .'.php');}

    $iMaxInputVars = ini_get('max_input_vars');

    $dirs = directory_list(WB_PATH.MEDIA_DIRECTORY);
    $dirs[] = WB_PATH.MEDIA_DIRECTORY;

    $aInputs = $oRequest->getParamNames();
    $iInputs = sizeof($dirs)*2;
    $ErrMsg  = '';
//Save post vars to the parameters file
//    $action = $oRequest->getParam('save', FILTER_SANITIZE_STRING);
    if (\in_array('save',$aInputs)){

    //if ( !is_null($admin->get_post("save"))) {
    /*
        if (!$admin->checkFTAN())
        {
            $admin->print_error('::'.$MESSAGE['GENERIC_SECURITY_ACCESS'],'browse.php',false);
        }
    */

        if (DEFAULT_THEME != ' wb_theme') {
            //Check for existing settings entry, if not existing, create a record first!
            if (!$database->get_one( "SELECT COUNT(*) FROM `".TABLE_PREFIX."settings` where `name`='mediasettings'" )) {
                $database->query( "INSERT INTO `".TABLE_PREFIX."settings` (`name`,`value`) VALUES ('mediasettings','')" );
            }
        } else {
            $pathsettings = [];
        }
/*
        $dirs = directory_list(WB_PATH.MEDIA_DIRECTORY);
        $dirs[] = WB_PATH.MEDIA_DIRECTORY;
*/
        foreach($dirs as $name) {
            $r = str_replace(WB_PATH.MEDIA_DIRECTORY, '', $name);
            $r = str_replace(array('/',' '),'_',$r);
            $w = (int)$admin->get_post($r.'-w');
            $h = (int)$admin->get_post($r.'-h');
            $pathsettings[$r]['width']=$w;
            $pathsettings[$r]['height']=$h;
        }  // end foreach
        $pathsettings['global']['admin_only'] = ($admin->get_post('admin_only')!='' ? 'checked="selected"':'');
        $pathsettings['global']['show_thumbs'] = ($admin->get_post('show_thumbs')!=''?'checked="selected"':'');
        $fieldSerialized = serialize($pathsettings);
        $database->query ( "UPDATE `".TABLE_PREFIX."settings` SET `value` = '$fieldSerialized' WHERE `name`='mediasettings'" );
        header ("Location: browse.php");
        exit();
    } // save end

    if (!function_exists('__unserialize')){include(__DIR__.'/parameters.php');}
    if ($_SESSION['GROUP_ID'] != 1 && (isset($pathsettings['global'])&&$pathsettings['global']['admin_only'])) {
        echo "Sorry, settings not available";
        exit();
    }
// Read data to display
    $caller = "setparameter";

// Setup template object, parse vars to it, then parse it
// Create new template object
    $template = new \vendor\phplib\Template(dirname($admin->correct_theme_source('setparameter.htt')));
    $template->set_file('page', 'setparameter.htt');
    $template->set_block('page', 'main_block', 'main');
    $template->set_block('main_block', 'table_tfoot_block', 'table_tfoot');
    $template->set_block('main_block', 'table_message_block', 'table_message');
    $template->set_block('main_block', 'table_save_block', 'table_save');

    if ($iInputs > $iMaxInputVars){
      $ErrMsg = \sprintf('PHP configuration "max_input_vars" (see php.ini) must be increased from %d to %d (or greater). Saving the optionen would fail and was disabled',$iMaxInputVars, $iInputs);
#      \trigger_error($ErrMsg, E_USER_WARNING);
        $template->parse('table_message', 'table_message_block', true);
        $template->set_block('table_save_block', '');
        $template->set_block('table_tfoot_block', '');
    } else {
        $template->set_block('table_message_block', '');
        $template->parse('table_save', 'table_save_block', true);
        $template->parse('table_tfoot', 'table_tfoot_block', true);
    }
    if ($_SESSION['GROUP_ID'] != 1) {
        $template->set_var('DISPLAY_ADMIN', 'hide');
    }
    $template->set_var(array(
                    'TEXT_HEADER' => $TEXT['TEXT_HEADER'],
                    'MESSAGE' => $ErrMsg,
                    'SAVE_TEXT' => $TEXT['SAVE'],
                    'BACK' => $TEXT['BACK'],
                )
            );

    $template->set_block('main_block', 'list_block', 'list');

    $row_bg_color = '';
    $dirs = directory_list(WB_PATH.MEDIA_DIRECTORY);
    $dirs[] = WB_PATH.MEDIA_DIRECTORY;
/*
print '<pre  class="mod-pre rounded">function <span>'.__FUNCTION__.'( '.''.' );</span>  filename: <span>'.basename(__FILE__).'</span>  line: '.__LINE__.' -> <br />';
print_r( sizeof($dirs) ); print '</pre>'; flush (); //  ob_flush();;sleep(10); die();
*/
    $array_lowercase = array_map('strtolower', $dirs);
    array_multisort($array_lowercase, SORT_ASC, SORT_STRING, $dirs);
    $id=0;
    foreach($dirs AS $name) {
        $relative = str_replace(WB_PATH.MEDIA_DIRECTORY, '', $name);
        $safepath = str_replace(array('/',' '),'_',$relative);
        $cur_width = $cur_height = '';
        if (isset($pathsettings[$safepath]['width'])) $cur_width = $pathsettings[$safepath]['width'];
        if (isset($pathsettings[$safepath]['height'])) $cur_height = $pathsettings[$safepath]['height'];
        $cur_width = ($cur_width ? (int)$cur_width : '-');
        $cur_height = ($cur_height ? (int)$cur_height : '-');
        $id++;
        $admin_only = isset($pathsettings['global']) ? $pathsettings['global']['admin_only'] : false;
        $show_thumbs = isset($pathsettings['global']) ? $pathsettings['global']['show_thumbs'] : false;
        if($row_bg_color == 'DEDEDE') $row_bg_color = 'EEEEEE';
        else $row_bg_color = 'DEDEDE';
        $template->set_var(array(
                        'ADMIN_URL' => ADMIN_URL,
                        'PATH_NAME' => $relative,
                        'WIDTH' => $TEXT['WIDTH'],
                        'HEIGHT' => $TEXT['HEIGHT'],
                        'FIELD_NAME_W' => $safepath.'-w',
                        'FIELD_NAME_H' => $safepath.'-h',
                        'CUR_WIDTH' => $cur_width,
                        'CUR_HEIGHT' => $cur_height,
                        'SETTINGS' => $TEXT['SETTINGS'],
                        'ADMIN_ONLY' => $TEXT['ADMIN_ONLY'],
                        'ADMIN_ONLY_SELECTED' => $admin_only,
                        'NO_SHOW_THUMBS' => $TEXT['NO_SHOW_THUMBS'],
                        'NO_SHOW_THUMBS_SELECTED' => $show_thumbs,
                        'ROW_BG_COLOR' => $row_bg_color,
                        'THEME_URL' => THEME_URL,
                        'FTAN' => $admin->getFTAN(),
                        'FILE_ID' => $id,
                    )
            );
        $template->parse('list', 'list_block', true);
    }

    $template->parse('main', 'main_block', false);
    $template->pparse('output', 'page');
