<?php
/**
 *
 * @category        admin
 * @package         users
 * @author          WebsiteBaker Project
 * @copyright       Ryan Djurovich
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.10.1
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: index.php 66 2018-09-17 15:48:07Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/admin/users/index.php $
 * @lastmodified    $Date: 2018-09-17 17:48:07 +0200 (Mo, 17. Sep 2018) $
 *
 */

if (!\defined('SYSTEM_RUN')) {require( \dirname(\dirname((__DIR__))).'/config.php');}

$admin = new \admin('Access', 'users');

$iUserStatus = 1;
$iUserStatus = ( ( $admin->get_get('status')==1 ) ? 0 : $iUserStatus );
unset($_GET);

$oTrans = \Translate::getInstance();
$oTrans->enableAddon(ADMIN_DIRECTORY.'\\users');
// Setup template object, parse vars to it, then parse it
// Create new template object
$template = new \vendor\phplib\Template(dirname($admin->correct_theme_source('users.htt')));
// $template->debug = true;

$template->set_file('page', 'users.htt');
$template->set_block('page', 'main_block', 'main');
$template->set_block("main_block", "manage_groups_block", "groups");
$template->set_var('ADMIN_URL', ADMIN_URL);
$template->set_var('FTAN', $admin->getFTAN());
$template->set_var('USER_STATUS', $iUserStatus );

$UserStatusActive = 'url('.THEME_URL.'/images/user.png)';
$UserStatusInactive = 'url('.THEME_URL.'/images/user_red.png)';

$sUserTitle  = ($iUserStatus == 0) ? \strtolower($oTrans->TEXT_ACTIVATED) : \strtolower($oTrans->TEXT_DEACTIVED);
$sUserTitle .= ' '.$oTrans->MENU_USER;

$template->set_var('TEXT_USERS', $oTrans->TEXT_SHOW.' '.$sUserTitle );
$template->set_var('STATUS_ICON', ( ($iUserStatus==0) ? $UserStatusActive : $UserStatusInactive) );

// Get existing value from database
$sql  = 'SELECT `user_id`, `username`, `display_name`, `active` FROM `'.TABLE_PREFIX.'users` ' ;
$sql .= 'WHERE user_id != 1 ';
$sql .=   'AND active = '.$iUserStatus.' ';
$sql .= 'ORDER BY `display_name`,`username`';

$results = $database->query($sql);
if($database->is_error()) {
    $admin->print_error($database->get_error(), 'index.php');
}

$sUserList  = $oTrans->TEXT_LIST_OPTIONS.' ';
$sUserList .= ($iUserStatus == 1) ? \strtolower($oTrans->TEXT_ACTIVATED) : \strtolower($oTrans->TEXT_DEACTIVED) ;
// Insert values into the modify/remove menu
$template->set_block('main_block', 'list_block', 'list');
if($results->numRows() > 0) {
    // Insert first value to say please select
    $template->set_var('VALUE', '');
    $template->set_var('NAME', $sUserList);
    $template->set_var('STATUS', 'class="user-active"' );
    $template->parse('list', 'list_block', true);
    // Loop through users
    while($user = $results->fetchRow(MYSQLI_ASSOC)) {
        $template->set_var('VALUE',$admin->getIDKEY($user['user_id']));
        $template->set_var('STATUS', ($user['active']==false ? 'class="user-inactive"' : 'class="user-active"') );
        $template->set_var('NAME', $user['display_name'].' ('.$user['username'].')');
        $template->parse('list', 'list_block', true);
    }
} else {
    // Insert single value to say no users were found
    $template->set_var('NAME', $oTrans->TEXT_NONE_FOUND);
    $template->parse('list', 'list_block', true);
}

// Insert permissions values
if($admin->get_permission('users_add') != true) {
    $template->set_var('DISPLAY_ADD', 'hide');
}
if($admin->get_permission('users_modify') != true) {
    $template->set_var('DISPLAY_MODIFY', 'hide');
}
if($admin->get_permission('users_delete') != true) {
    $template->set_var('DISPLAY_DELETE', 'hide');
}
$HeaderTitle  = (($iUserStatus == 1) ? $oTrans->HEADING_MODIFY_ACTIVE_USER.' ' : $oTrans->HEADING_MODIFY_DELETE_USER.' ');
//$HeaderTitle .= (($iUserStatus == 1) ? strtolower($oTrans->TEXT_ACTIVE) : strtolower($oTrans->TEXT_DEACTIVED));
// Insert language headings
$template->set_var(array(
        'HEADING_MODIFY_DELETE_USER' => $HeaderTitle,
        'HEADING_ADD_USER' => $oTrans->HEADING_ADD_USER
        )
);
// insert urls
$template->set_var(array(
        'ADMIN_URL' => ADMIN_URL,
        'WB_URL' => WB_URL,
        'THEME_URL' => THEME_URL
        )
);
// Insert language text and messages
$template->set_var(array(
        'TEXT_MODIFY' => $oTrans->TEXT_MODIFY,
        'TEXT_DELETE' => (($iUserStatus == 1) ? $oTrans->TEXT_DEACTIVE:$oTrans->TEXT_DELETE),
        'TEXT_MANAGE_GROUPS' => ( $admin->get_permission('groups') == true ) ? $oTrans->TEXT_MANAGE_GROUPS : "**",
        'CONFIRM_DELETE' => (($iUserStatus == 1) ? $oTrans->TEXT_ARE_YOU_SURE : $oTrans->MESSAGE_USERS_CONFIRM_DELETE)
        )
);
if ( $admin->get_permission('groups') == true ) $template->parse("groups", "manage_groups_block", true);
// Parse template object
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');

if (isset($_SESSION['users'])){
}

// Setup template object, parse vars to it, then parse it
// Create new template object
$template = new \vendor\phplib\Template(\dirname($admin->correct_theme_source('users_form.htt')));
// $template->debug = true;
$template->set_file('page', 'users_form.htt');
$template->set_block('page', 'main_block', 'main');
$template->set_block('main_block', 'user_display_block', 'user_display');

$template->set_var('DISPLAY_EXTRA', 'display:none;');
$template->set_var('ACTIVE_CHECKED', ' checked="checked"');
$template->set_var('ACTION_URL', ADMIN_URL.'/users/add.php');
$template->set_var('SUBMIT_TITLE', $oTrans->TEXT_ADD);
$template->set_var('FTAN', $admin->getFTAN());
// {READONLY}
$template->set_var('READONLY', '' );

// insert urls
$template->set_var(array(
        'ADMIN_URL' => ADMIN_URL,
        'WB_URL' => WB_URL,
        'THEME_URL' => THEME_URL
        )
);
$template->set_var('USERNAME', '');

// Add groups to list
$template->set_block('main_block', 'group_list_block', 'group_list');
$results = $database->query("SELECT `group_id`, `name` FROM `".TABLE_PREFIX."groups` WHERE `group_id` != '1'");
if($results->numRows() > 0) {
    $template->set_var('ID', '');
    $template->set_var('NAME', $oTrans->TEXT_PLEASE_SELECT.'...');
//    $template->set_var('SELECTED', ' selected="selected"');
    $template->parse('group_list', 'group_list_block', true);
    while($group = $results->fetchRow(MYSQLI_ASSOC)) {
        $template->set_var('ID', $group['group_id']);
        $template->set_var('NAME', $group['name']);
        $template->set_var('SELECTED', '');
        if ($admin->is_group_match($group['group_id'], (isset($_SESSION['users']['groups_id']) ? $_SESSION['users']['groups_id'] : '')))
        {
            $template->set_var('SELECTED', ' selected="selected"');
        }
        $template->parse('group_list', 'group_list_block', true);
    }
}
// Only allow the user to add a user to the Administrators group if they belong to it
if(in_array(1, $admin->get_groups_id())) {
    $users_groups = $admin->get_groups_name();
    $template->set_var('ID', '1');
    $template->set_var('NAME', $users_groups[1]);
    $template->set_var('SELECTED', '');
    $template->parse('group_list', 'group_list_block', true);
} else {
    if($results->numRows() == 0) {
        $template->set_var('ID', '');
        $template->set_var('NAME', $oTrans->TEXT_NONE_FOUND);
        $template->parse('group_list', 'group_list_block', true);
    }
}

// Insert permissions values

if($admin->get_permission('users_add') != true) {
    $template->set_var('DISPLAY_ADD', 'hide');
}

// Generate username field name
$username_fieldname = 'username_';
$salt = "abchefghjkmnpqrstuvwxyz0123456789";
\srand((double)\microtime()*1000000);
$i = 0;
while ($i <= 7) {
    $num = \rand() % 33;
    $tmp = \substr($salt, $num, 1);
    $username_fieldname = $username_fieldname . $tmp;
    $i++;
}
            $template->set_var(array(
                      'USERNAME_FIELDNAME' => $username_fieldname,
                      'USERNAME' => (isset($_SESSION['users']) ? $_SESSION['users']['login_name'] : ''),
                      'DISPLAY_NAME' => (isset($_SESSION['users']) ? $_SESSION['users']['display_name'] : ''),
                      'EMAIL' => (isset($_SESSION['users']) ? $_SESSION['users']['email'] : ''),
                      )
                  );

// Include the WB functions file
    if (!\function_exists('directory_list')){require(WB_PATH.'/framework/functions.php');}
// Work-out if home folder should be shown
        $template->set_block('main_block', 'folder_list_block', 'folder_list');
        if (HOME_FOLDERS) {
            $template->set_var('DISPLAY_HOME_FOLDERS', '');
// Add media folders to home folder list
            $aFiles = directory_list(WB_PATH.MEDIA_DIRECTORY);
            \array_unshift($aFiles, MEDIA_DIRECTORY );
            foreach($aFiles as $name){
                $sItem  = \str_replace(WB_PATH.MEDIA_DIRECTORY, '', $name);
                $iLevel = (int)\substr_count($sItem, '/')-1;
                $sPrefix = \str_repeat('&#160;&#160;&#160;',$iLevel);
                $template->set_var('NAME', $sPrefix.\basename($sItem));
                $template->set_var('LEVEL', $iLevel);
                $template->set_var('FOLDER', $sItem);
                $template->set_var('SELECTED', '');
                $template->parse('folder_list', 'folder_list_block', true);
            }
        }
        if(!HOME_FOLDERS) {
            $template->set_var('DISPLAY_HOME_FOLDERS', ' style="display: none;"');
        }

// Insert language text and messages
$template->set_var(array(
            'TEXT_CANCEL' => $oTrans->TEXT_CANCEL,
            'TEXT_RESET' => $oTrans->TEXT_RESET,
            'TEXT_ACTIVE' => $oTrans->TEXT_ACTIVE,
            'TEXT_DISABLED' => $oTrans->TEXT_DISABLED,
            'TEXT_PLEASE_SELECT' => $oTrans->TEXT_PLEASE_SELECT,
            'TEXT_USERNAME' => $oTrans->TEXT_USERNAME,
            'TEXT_PASSWORD' => $oTrans->TEXT_PASSWORD,
            'TEXT_RETYPE_PASSWORD' => $oTrans->TEXT_RETYPE_PASSWORD,
            'TEXT_DISPLAY_NAME' => $oTrans->TEXT_DISPLAY_NAME,
            'TEXT_EMAIL' => $oTrans->TEXT_EMAIL,
            'TEXT_GROUP' => $oTrans->TEXT_GROUP,
            'TEXT_NONE' => $oTrans->TEXT_NONE,
            'TEXT_HOME_FOLDER' => $oTrans->TEXT_HOME_FOLDER,
            'CHANGING_PASSWORD' => $oTrans->MESSAGE_USERS_CHANGING_PASSWORD,
            'CANCEL_LINK' => ADMIN_URL.'/access/index.php',
            )
    );
$template->set_block( 'user_display_block', '');

// Parse template for add user form
$template->parse('main', 'main_block', false);
$template->pparse('output', 'page');
unset($_SESSION['users']);
$admin->print_footer();
