<?php
/**
 *
 * @category        admin
 * @package         login
 * @author          Ryan Djurovich, WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://www.websitebaker2.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: wb_info.php 344 2019-05-06 18:59:56Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/framework/helpers/wb_info.php $
 * @lastmodified    $Date: 2019-05-06 20:59:56 +0200 (Mo, 06. Mai 2019) $
 *
 */

if (!\defined('SYSTEM_RUN')) {require( (\dirname(dirname((__DIR__)))).'/config.php');}

$admin = new admin('##skip##','start', false, false);
if (!$admin->is_authenticated() || !$admin->ami_group_member('1')){
    throw new \RuntimeException('Illegal file access!');
}
if (!\class_exists('Twig_Autoloader')) {
    $msg = 'This modul requires TWIG. please download from <a href="http://wiki.'
         . 'websitebaker.org/doku.php/en/downloads"  ><b>wiki.wb</a></b>...';
    throw new \RuntimeException($msg);
} else {
    $aWritablePaths = array(
        'languages',
        'media',
        'modules',
        'pages',
        'temp',
        'templates',
        'var',
        );
    if (\is_readable(WB_PATH.'/modules/SimpleRegister.php')){
      require WB_PATH.'/modules/SimpleRegister.php';
    }
    $oInfo = new \bin\helpers\SysInfo();

    if (\is_object($oReg->Db->DbHandle)) {
        $title = "MySQLi Info";
        $server_info          = \mysqli_get_server_info($oReg->Db->DbHandle);
        $host_info            = \mysqli_get_host_info($oReg->Db->DbHandle);
        $proto_info           = \mysqli_get_proto_info($oReg->Db->DbHandle);
        $client_info          = \mysqli_get_client_info($oReg->Db->DbHandle);
        $client_encoding      = \mysqli_character_set_name($oReg->Db->DbHandle);
        $status = \explode('  ', \mysqli_stat($oReg->Db->DbHandle));
    }
    $sFilename = 'upgrade-script.php';
// Create new Template object with phplib
    $aTwigData = array(
        'WB_URL' => $oReg->AppUrl,
        'IS_ADMIN'  => ($admin->get_user_id()==1),
        'UPGRADE_URL' => (\file_exists($oReg->AppPath.$sFilename) ? $oReg->AppUrl.$sFilename : $oReg->AppUrl),
        'THEME_URL' => $oReg->ThemeUrl,
        'HELPER_URL' =>  $oReg->AppUrl.'framework/helpers',
        'JQUERY_VERSION' => JQUERY_VERSION,
        'sAddonThemeUrl' => THEME_URL.'',
        'getInterface' => $oInfo->getInterface(),
        'isCgi' => $oInfo->isCgi(),
        'WbVersion' => $oInfo->getWbVersion(true),
        'getOsVersion' => $oInfo->getOsVersion(true),
        'aWritablePaths' => $oInfo->checkFolders($aWritablePaths),
        'getSqlServer' => $oInfo->getSqlServer(),
        'client_encoding' => $client_encoding,
        'php_version' => \PHP_VERSION,
        'oReg' => $oReg,
        'server' => $oReg->Db->db_handle,
        'client_info' => $client_info,
        'server_info' => $server_info,
    );
    $aTwigloader = array('header'=> 'header.twig',
                         'content' => 'content.twig',
                         'sysinfo' => 'sysInfo.twig',
                         'footer'  => 'footer.twig'
               );
    if (\is_readable($oReg->ThemePath.'templates/'.$aTwigloader['sysinfo'])){
        $loader = new Twig_Loader_Filesystem($oReg->ThemePath . 'templates');
        $Twig = new Twig_Environment(
            $loader, array(
            'autoescape'       => false,
            'cache'            => false,
            'strict_variables' => false,
            'debug'            => false,
            ));
/*-- finalize the page -----------------------------------------------------------------*/
        echo $Output = $Twig->Render($aTwigloader['sysinfo'], $aTwigData);//
    } else {
    }
}

