<?php

// $Id: create_ttf_image.php 334 2019-04-13 05:30:57Z Luisehahne $

 /* -------------------------------------------------------- */
if ( !defined( 'SYSTEM_RUN' ) ){ require( dirname(dirname(dirname((__DIR__)))).'/config.php' ); }
/* -------------------------------------------------------- */
try {
    if (!function_exists('display_captcha_real')) {require (WB_PATH.'/include/captcha/captcha.php');}
    $admin = new admin('##skip##', false,false);
    require_once(WB_PATH.'/framework/functions.php');
    if (isset($_GET['captchaId'])){ $mIdKey = $admin->StripCodeFromText($_GET['captchaId']);}
// make random string
    if(!function_exists('randomString')) {
        function randomString($len) {
            list($usec, $sec) = explode(' ', microtime());
            mt_srand((float)$sec + ((float)$usec * 100000));
            //$possible="ABCDEFGHJKLMNPRSTUVWXYZabcdefghkmnpqrstuvwxyz23456789";
            $possible="abdfhkrsvwxz23456789";
            $str="";
            while(strlen($str)<$len) {
                $str.=substr($possible,(mt_rand()%(strlen($possible))),1);
            }
            return($str);
        }
    }

    $text = randomString(5); // number of characters
    $_SESSION['captcha'.$mIdKey] = $text;

    $fonts   = [];
    $t_fonts = file_list(WB_PATH.'/include/captcha/fonts');
    foreach($t_fonts as $file) { if(preg_match('/\.ttf/',$file)) { $fonts[]=$file; } }

    $bgs     = [];
    $t_bgs   = file_list(WB_PATH.'/include/captcha/backgrounds');
    foreach($t_bgs   as $file) { if(preg_match('/\.png/',$file)) { $bgs[]=$file; } }
    // choose a font and background
    $font = $fonts[array_rand($fonts)];
    $bg   = $bgs[array_rand($bgs)];
// get image-dimensions
    list($width, $height, $type, $attr) = getimagesize($bg);

    // create reload-image
    $reload = ImageCreateFromPNG(WB_PATH.'/include/captcha/reload_140_40.png'); // reload-overlay
    if(mt_rand(0,2)==0) { // 1 out of 3
        // draw each character individualy
        $image   = ImageCreateFromPNG($bg); // background image
        $grey    = mt_rand(0,50);
        $color   = ImageColorAllocate($image, $grey, $grey, $grey); // font-color
        $ttf     = $font;
        $ttfsize = 25; // fontsize
        $count   = 0;
        $image_failed = true;
        $angle   = mt_rand(-15,15);
        $x       = mt_rand(10,25);
        $y       = mt_rand($height-10,$height-2);
        do {
            for($i=0;$i<strlen($text);$i++) {
                $res   = imagettftext($image, $ttfsize, $angle, $x, $y, $color, $ttf, $text{$i});
                $angle = mt_rand(-15,15);
                $x     = mt_rand($res[4],$res[4]+10);
                $y     = mt_rand($height-15,$height-5);
            }
            if($res[4] > $width) {
                $image_failed = true;
            } else {
                $image_failed = false;
            }
            if(++$count > 4) // too many tries! Use the image
                break;
        } while($image_failed);
    } else {
        // draw whole string at once
        $image_failed = true;
        $count=0;
        do {
            $image = ImageCreateFromPNG($bg); // background image
            $grey = mt_rand(0,50);
            $color = ImageColorAllocate($image, $grey, $grey, $grey); // font-color
            $ttf = $font;
            $ttfsize = 24; // fontsize
            $angle = mt_rand(0,5);
            $x = mt_rand(5,30);
            $y = mt_rand($height-10,$height-2);
            $res = imagettftext($image, $ttfsize, $angle, $x, $y, $color, $ttf, $text);
            // check if text fits into the image
            if(($res[0]>0 && $res[0]<$width) && ($res[1]>0 && $res[1]<$height) &&
                 ($res[2]>0 && $res[2]<$width) && ($res[3]>0 && $res[3]<$height) &&
                 ($res[4]>0 && $res[4]<$width) && ($res[5]>0 && $res[5]<$height) &&
                 ($res[6]>0 && $res[6]<$width) && ($res[7]>0 && $res[7]<$height)
            ) {
                $image_failed = false;
            }
            if(++$count > 4) // too many tries! Use the image
                break;
        } while($image_failed);

    }

    imagealphablending($reload, TRUE);
    imagesavealpha($reload, TRUE);

    // overlay
    imagecopy($reload, $image, 0,0,0,0, 140,40);
    imagedestroy($image);
    $image = $reload;

    if(!function_exists('captcha_header')) {
        throw new Exception( 'Can\'t call function captcha_header');
    }
    ob_start();
    captcha_header();
    imagepng($image);
    header("Content-Length: ".ob_get_length());
    ob_end_flush();
    imagedestroy($image);
} catch (Exception $e) {
    echo 'Exception abgefangen: ',  $e->getMessage(), "\n";
}
