<?php
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; \flush(); exit;}
/* -------------------------------------------------------- */
?><?php
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * SimpleCommandDispatcher.inc.php
 *
 * @category     Addons
 * @package      Addons_Dispatcher
 * @copyright    Manuela v.d.Decken <manuela@isteam.de>
 * @author       Manuela v.d.Decken <manuela@isteam.de>
 * @license      http://www.gnu.org/licenses/gpl.html   GPL License
 * @version      3.0.1
 * @lastmodified $Date: 2019-03-27 03:31:23 +0100 (Mi, 27. Mrz 2019) $
 * @since        File available since 17.12.2015
 * @description  xyz
 */

    if (\is_readable((__DIR__).'/SimpleRegister.php')){
        require (__DIR__).'/SimpleRegister.php';
    } else {
        throw new \Exception('Call of an invalid WebsiteBaker Version ['.WB_VERSION.' '.WB_SP.'] failed!');
    }
#    $oDispatcher = null;
    // detect if system running backend or frontend is already set by SimpleRegister
//    $oApp = (isset($GLOBALS['admin']) ? $GLOBALS['admin'] : $GLOBALS['wb']);
    $bExcecuteCommand = (isset($bExcecuteCommand) ? $bExcecuteCommand : true);
    $bIsBackend = ($oApp instanceof \admin);
    $sAddonType = (!isset($sAddonType) ? 'modules/' : rtrim($sAddonType,'s/').'s/');
    // set addon depending path / url
    $sAddonPath = $oReg->AppPath.$sAddonType.$sAddonName;
    $sAddonUrl  = $oReg->AppUrl.$sAddonType.$sAddonName;
    $sAddonRel = '/'.$sAddonType.$sAddonName;

    $sAddonThemeRel = '/themes/default';
    $sAddonTemplateRel = '/templates/default';

    // define the theme to use -----------------------------------------------------------
    if (\is_readable($sAddonPath.'/themes/default')) {
    // first set fallback to system default theme
    }
    if (\is_readable($sAddonPath.'/themes/'.$oReg->DefaultTheme)) {
    // overload with the selected theme if accessible
        $sAddonThemeRel = '/themes/'.$oReg->DefaultTheme;
    }
    $sAddonThemePath = $sAddonPath.$sAddonThemeRel;
    $sAddonThemeUrl  = $sAddonUrl.$sAddonThemeRel;
    // define the template to use --------------------------------------------------------
    if (\is_readable($sAddonPath.'/templates/default')) {
        // first set fallback to system default template
    }
    if (\is_readable($sAddonPath.'/templates/'.$oReg->DefaultTemplate)) {
        // try setting to the template of global settings
        $sAddonTemplateRel = '/templates/'.$oReg->DefaultTemplate;
    }
    if (!$bIsBackend && \is_readable($sAddonPath.'/templates/'.$oReg->Template)) {
        // try setting to the template of page depending settings
        $sAddonTemplateRel = '/templates/'.$oReg->Template;
    }
    $sAddonTemplatePath = $sAddonPath.$sAddonTemplateRel;
    $sAddonTemplateUrl  = $sAddonUrl.$sAddonTemplateRel;

    // load addon depending language file ------------------------------------------------

        if (\is_readable($sAddonPath.'/languages/EN.php')) {
            // first load fallback to system default language (EN)
            include $sAddonPath.'/languages/EN.php';
        }
        if (\is_readable($sAddonPath.'/languages/'.$oReg->DefaultLanguage.'.php')) {
            // try loading language of global settings
            include $sAddonPath.'/languages/'.$oReg->DefaultLanguage.'.php';
        }
        if (\is_readable($sAddonPath.'/languages/'.$oReg->Language.'.php')) {
            // try loading language of user (backend) or page (frontend) defined settings
            include $sAddonPath.'/languages/'.$oReg->Language.'.php';
        }
        \Translate::getInstance()->enableAddon ('modules\\'.$sAddonName);

        // load addon Theme/Template depending language file ---------------------------------
        $sTmp = ($bIsBackend ? $sAddonThemePath : $sAddonTemplatePath).'/languages/';
        if (\is_readable($sTmp.'EN.php')) {
            // first load fallback to system default language (EN)
            include $sTmp.'EN.php';
            if (\is_readable($sTmp.$oReg->DefaultLanguage.'.php')) {
                // try loading language of global settings
                include $sTmp.$oReg->DefaultLanguage.'.php';
            }
            if (\is_readable($sTmp.$oReg->Language.'.php')) {
                // try loading language of user (backend) or page (frontend) defined settings
                include $sTmp.$oReg->Language.'.php';
            }
            \Translate::getInstance()->enableAddon ('modules\\'.$sAddonName.'\\'.$sAddonThemeRel);
        }

        ${'a'.$sAddonName.'Lang'} = \Translate::getInstance()->getLangArray();

    // Simple Command Dispatcher ---------------------------------------------------------
     // Include the ordering class

    // sanitize command from compatibility file
    $sCommand = (isset($sCommand) ? ($sCommand) : ''); //  strtolower
    // sanitize/validate request var 'cmd'
    $sCmd = \preg_replace(
        '/[^a-z\/0-1]/siu',
        '',
        (isset($_REQUEST['cmd']) ? \strtolower($_REQUEST['cmd']) : '')
    );
    // build valid sCommand string
    if (($sCommand && $sCmd)) {
        if (!\preg_match('/^'.$sCommand.'/si', $sCmd)) {
            // concate both arguments if needed
            $sCommand .= '/'.$sCmd;
        } else {
            $sCommand = $sCmd;
        }
        $sCmd = '';
    }

    $sCommand = \str_replace( // remove spaces and add prefix 'cmd'
        ' ', '',
        \ucfirst( // make first char of every word to uppercase
            \str_replace( // change '/' to space
                '/', ' ',
                \preg_replace( // change leading 'add/' to 'modify/'
                    '/^add\//s',
                    'modify/',
                    \trim(($sCommand ?: $sCmd), '/') // remove leading and trailing slashes
                )
            )
        )
    );
    $aDispatcher = [
          'AddonRel'           => $sAddonRel,
          'AddonPath'          => $sAddonPath,
          'AddonUrl'           => $sAddonUrl,
          'AddonThemeRel'      => $sAddonThemeRel,
          'AddonTemplateRel'   => $sAddonTemplateRel,
          'Command'            => $sCommand,
          'Adaptor'            => $oReg,
    ];
/*
    $oDispatcher = (object)compact(array_keys(get_defined_vars()));
*/
    if ($bExcecuteCommand){
// execute command -------------------------------------------------------------------

        if (\is_readable($sAddonPath.'/cmd/'.$sCommand.'.inc.php')) {
            include($sAddonPath.'/cmd/'.$sCommand.'.inc.php');
        } elseif (\is_readable($sAddonPath.'/cmd/'.$sCommand.'.inc')) {
            include($sAddonPath.'/cmd/'.$sCommand.'.inc');
        } elseif (\is_readable($sAddonPath.'/cmd/cmd'.$sCommand.'.inc')) {
            include($sAddonPath.'/cmd/cmd'.$sCommand.'.inc');
        } else {
            throw new \Exception('call of invalid command ['.$sCommand.'] for [modules/'.$sAddonName.'] failed!');
        }
    }

// end of file