<?php
/**
 *
 * @category        modules
 * @package
 * @subpackage
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: upgrade.php 257 2019-03-17 20:00:55Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/captcha_control/upgrade.php $
 * @lastmodified    $Date: 2019-03-17 21:00:55 +0100 (So, 17. Mrz 2019) $
 *
 */
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

if (!function_exists('mod_captcha_control_upgrade')){
    function mod_captcha_control_upgrade($bDebug=false) {
        global $OK ,$FAIL;
        $oDb = \database::getInstance();
        $msg = [];
        $aOutputMsg = [];
        $sAddonPath = __DIR__;
        $sInstallData = '';
        $sAddonName = basename($sAddonPath);
        if (!\function_exists('get_addon_variable')) {require (WB_PATH.'/framework/functions.php');}
        $sModuleName = get_addon_variable($sAddonName,'name');
// check if upgrade startet by upgrade-script to echo a message
        $globalStarted = preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
        $sModulePlatform = get_addon_variable($sAddonName,'platform');
        $sWbVersion = ($globalStarted && defined('VERSION') ? VERSION : WB_VERSION);
        if (version_compare($sWbVersion, $sModulePlatform, '<')){
            throw new Exception (sprintf('It is not possible to upgrade from WebsiteBaker Versions before %s',$sModulePlatform));
        }

        $sTable = TABLE_PREFIX.'mod_captcha_control';
        $sInstallStruct = __DIR__.'/install-struct.sql.php';
//  try to create table if not exists
        if (!$oDb->SqlImport($sInstallStruct, TABLE_PREFIX, 'upgrade')){
            $msg[] = sprintf('[%05d] %s',$oDb->get_errno(),$oDb->get_error());
        }
//  only if no data row found
        if (!$oDb->get_one('SELECT COUNT(*) '.$sTable.'')){
            $sInstallData = __DIR__.'/install-data.sql.php';
            if (!$oDb->SqlImport($sInstalldata, TABLE_PREFIX, 'upgrade')){
                $msg[] = sprintf('[%05d] %s',$oDb->get_errno(),$oDb->get_error());
            }
        }
        if (($sOldType = $oDb->getTableEngine($sTable))) {
            if (('myisam' != strtolower($sOldType))) {
                if (!$oDb->query('ALTER TABLE `'.$sTable.'` Engine = \'MyISAM\' ')) {
                    $msg[] = sprintf('[%05d] %s',$oDb->get_errno(),$oDb->get_error());
                }
            }
        } elseif ($oDb->get_errno()>0) {
            $msg[] = sprintf('[%05d] %s',$oDb->get_errno(),$oDb->get_error());
        }

//  remove obselete files and folder
        $aRemoveList = [
            '/themes/default/css/backend.css',
            ];
        $sAbsAddonPath = \str_replace('\\','',__DIR__);
        foreach ($aRemoveList as $sFilename){
            if (is_writeable($sAbsAddonPath.$sFilename)) {
                if (substr($sFilename, -1)==='/'){
                    rm_full_dir ($sAbsAddonPath.$sFilename);
                } else {
                    \unlink($sAbsAddonPath.$sFilename);
                }
            }
        } // end foreach
        if (count($msg)==0){
//            $msg[] = $sModuleName.' upgrade successfull finished '.$OK;
        }
        return ($globalStarted ?: $msg);
    }
}
// ------------------------------------

    $bDebugModus = ((isset($bDebugModus)) ? $bDebugModus : false);
    if (is_array($msg = mod_captcha_control_upgrade($bDebugModus))) {
        if (!$bDebugModus){
            echo '<b>'.implode('<br />',$msg).'</b><br />';
        }
    }
// ------------------------------------
