<?php
/**
 *
 * @category       modules
 * @package        ckeditor
 * @authors        WebsiteBaker Project, Michael Tenschert, Dietrich Roland Pehlke
 * @copyright      WebsiteBaker Org. e.V.
 * @link           http://websitebaker.org/
 * @license        http://www.gnu.org/licenses/gpl.html
 * @platform       WebsiteBaker 2.8.3
 * @requirements   PHP 5.3.6 and higher
 * @version        $Id: upgrade.php 276 2019-03-22 00:06:26Z Luisehahne $
 * @filesource     $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/ckeditor/upgrade.php $
 * @lastmodified   $Date: 2019-03-22 01:06:26 +0100 (Fr, 22. Mrz 2019) $
 *
 */

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; flush(); exit; }
/* -------------------------------------------------------- */
    // upgrade started by upgrade-script.php
    $globalStarted = preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = ($globalStarted && defined('VERSION') ? VERSION : WB_VERSION);
    if (version_compare($sWbVersion, '2.11.0', '<')){
        throw new Exception ('It is not possible to upgrade from WebsiteBaker Versions before 2.11.0');
    }

    if (!function_exists('rm_full_dir')){require WB_PATH.'/framework/functions.php';}
//Delete full directory with all files inside there

    if (is_writeable(__DIR__.'/ckeditor/plugins/wblink/plugin.js.bak')){
        unlink (__DIR__.'/ckeditor/plugins/wblink/plugin.js.bak');
    }

    $aRemoveList = [
        '/ckeditor/Lib/',
        '/ckeditor/plugins/a11yhelp/',
        '/ckeditor/plugins/alphamanager/',
        '/ckeditor/plugins/flash/',
        '/ckeditor/plugins/scayt/',
        '/ckeditor/plugins/wsc/',
        '/ckeditor/plugins/plugins/youtube/',
        '/ckeditor/plugins/wbdroplets/log/',
        '/ckeditor/plugins/wblink/log/',
        '/ckeditor/plugins/plugin.js',
        ];

    $sAbsAddonPath = \str_replace('\\','',__DIR__);
    foreach ($aRemoveList as $sFilename){
        if (is_writeable($sAbsAddonPath.$sFilename)) {
            if (substr($sFilename, -1)==='/'){
                rm_full_dir ($sAbsAddonPath.$sFilename);
            } else {
                \unlink($sAbsAddonPath.$sFilename);
            }
        }
    } // end foreach

