<?php
/**
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * @category        modules
 * @package         form
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.x
 * @requirements    PHP 5.6 and higher
 * @version         $Id: field_import.php 284 2019-03-22 08:13:16Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/form/field_import.php $
 * @lastmodified    $Date: 2019-03-22 09:13:16 +0100 (Fr, 22. Mrz 2019) $
 * @since           File available since  2017 sept 21
 * @description     xyz
 */
/* -------------------------------------------------------- */
if (!defined('SYSTEM_RUN')) {require( dirname(dirname((__DIR__))).'/config.php');}

$sAddonPath = (__DIR__);
$sAddonName = basename($sAddonPath);
$aMessage = [];
// suppress to print the header, so no new FTAN will be set
$admin_header = true;
// Tells script to update when this page was last updated
$update_when_modified = true;
// Include WB admin wrapper script
require(WB_PATH.'/modules/admin.php');

$requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
$aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

$removeExtension = (function ($sFilename){
    $sRetval = '';
    return preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', $sFilename);
});

$sSectionIdPrefix = (defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' );
$sBackUrl = ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'#'.$sSectionIdPrefix.$section_id;
$sBacklink = WB_URL.'/modules/'.$sAddonName.'/modify_backup.php';

if (!$admin->checkFTAN($requestMethod)){
    $admin->print_error( 'checkFTAN ::'.$MESSAGE['GENERIC_SECURITY_ACCESS'], $sBackUrl );
}
$version  = '1.0';
$encoding = 'utf-8';

//$sFilename     = $removeExtension(''.$admin->StripCodeFromText($aRequestVars['xml_file']));
$sFilename  = ($admin->StripCodeFromText(
                  isset($aRequestVars['xml_file']) && ($aRequestVars['xml_file']!='')
                ? $aRequestVars['xml_file']
                : (isset($aRequestVars['upload_file']) && ($aRequestVars['upload_file']!='')
                ? $aRequestVars['upload_file']
                : '')
                ) // end StripCodeFromText
              );

$sTargetPath  = $sAddonPath.'/data/fields/';
$sAbsFilename = $sTargetPath.$sFilename.'';

$action = 'cancel';
$action = (isset($aRequestVars['import'])?'import':$action);
$action = (isset($aRequestVars['delete'])?'delete':$action);

try {
    if (isset($aRequestVars['cmd'])&&(is_file($sAbsFilename)||($sFilename!=''))) {
        switch ($action):
            case 'import':
                $sql  = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_form_fields` '
                      . 'WHERE `section_id` = '.(int)$section_id.' '
                      . '';
                if ($database->get_one($sql)!=0){
                    $aMessage[] = sprintf('%1$.04d ) Couldn\'t import, because a Formular already exists in section '.$section_id, __LINE__);
                } else {
                    if ($oXml = simplexml_load_file($sAbsFilename)) {
                        foreach ($oXml->fields->field as $field) {
                            $position = $field->position;
                            $title    = $field->title;
                            $type     = $field->type;
                            $required = $field->required;
                            $extra    = $field->extra;
                            $value    = $field->value;
    //                        print '<hr>'.$field->title.' Typ = '.$field->type;
                            $sql  = 'INSERT INTO `'.TABLE_PREFIX.'mod_form_fields` SET '
                                  . '`section_id` = '.(int)($section_id).', '
                                  . '`page_id` = '.(int)($page_id).', '
                                  . '`position`= '.(int)($position).', '
                                  . '`title`= \''.$database->escapeString($title).'\', '
                                  . '`type`= \''.$database->escapeString($type).'\', '
                                  . '`required`= '.(int)($required).', '
                                  . '`extra`= \''.$database->escapeString($extra).'\', '
                                  . '`value`= \''.$database->escapeString($value).'\' ';
                            if (!$oRes = $database->query($sql)) {
                              $aMessage[] = $sql.'<br />';
                              $aMessage[] = 'Invalid query: ' . $database->get_error();
                            }
                        }// end foreach
                    }
                }
                break;
            case 'delete':
              if (!unlink($sAbsFilename)){
                  $aMessage[] = sprintf('%1$.04d ) Couldn\'t delete '.$sFilename.'<br />', __LINE__);
              }
              break;
            default:
        endswitch;
    } else {
        $aMessage[] = sprintf('%1$4d ) File does not exist or no file selected!'.'!<br />', __LINE__);
    }

} catch ( Exception $e ){
    $aMessage[] = sprintf('%1$.04d ) Tried to set form in DOMElement!<br />'.$e, __LINE__);
}

    $sBacklink .= '?page_id='.$page_id.'&frm_id='.$admin->getIDKEY($section_id);
    if (!sizeof($aMessage)){
        switch ($action):
            case 'import':
                $admin->print_success(sprintf($FORM_MESSAGE['IMPORT_SUCCESS'],$sFilename), $sBackUrl );
                break;
            case 'delete':
            $admin->print_success(sprintf($FORM_MESSAGE['IMPORT_DELETED'],$sFilename), $sBackUrl);
              break;
            default:
        endswitch;
    } else {
      $admin->print_error(implode('<br />',$aMessage), $sBackUrl);
    }

// Print admin footer
    $admin->print_footer();
// end of file
//