<?php
/**
 *
 * @category        modules
 * @package         form
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.x
 * @requirements    PHP 5.6 and higher
 * @version         $Id: modify.php 341 2019-04-27 14:40:31Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/form/modify.php $
 * @lastmodified    $Date: 2019-04-27 16:40:31 +0200 (Sa, 27. Apr 2019) $
 * @description
 */
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 File not found'; flush(); exit;}
/* -------------------------------------------------------- */

//overwrite php.ini on Apache servers for valid SESSION ID Separator
$sQuerySep = \ini_get('arg_separator.output');
//if(function_exists('ini_set')) {
//    ini_set('arg_separator.output', '&amp;');
//}

$sModulName = \basename(__DIR__);
$sModulName = $sModulName;
$sAddonName = \basename(__DIR__);
$ModuleRel = '/modules/'.\basename(__DIR__).'/';
$ModuleUrl = WB_URL.'/modules/'.\basename(__DIR__).'/';
$ModulePath = WB_PATH.'/modules/'.\basename(__DIR__).'/';

// load module language file
if (\is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (\is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (\is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

$oLang = Translate::getInstance();
$oLang->enableAddon('modules\\'.\basename(__DIR__));

if (!\function_exists( 'make_dir')) {require(WB_PATH.'/framework/functions.php');}

$SectionIdPrefix = '#'.(defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' ).$section['section_id'];
$backModuleUrl = ADMIN_URL.'/pages/sections.php?page_id='.$page_id;
//http://wb283.wdsnet.local/admin/pages/sections.php?page_id=13
//Delete all form fields with no title
$sql  = 'DELETE FROM `'.TABLE_PREFIX.'mod_form_fields` ';
$sql .= 'WHERE page_id = '.(int)$page_id.' ';
$sql .=   'AND section_id = '.(int)$section_id.' ';
$sql .=   'AND title=\'\' ';
if (!$database->query($sql)) {
// error msg
}
$bCanBackup = ($admin->ami_group_member('1') || $admin->get_permission('settings')); // true false
$bCanDelete = ($admin->ami_group_member('1') || $admin->get_permission('settings')); // true false
$bCanModifyOption = ($admin->get_permission('modules_settings') );

// later in upgrade.php
$table_name = TABLE_PREFIX.'mod_form_settings';
$field_name = 'perpage_submissions';
$description = "INT NOT NULL DEFAULT '10' AFTER `max_submissions`";
if (!$database->field_exists($table_name,$field_name)) {
    $database->field_add($table_name, $field_name, $description);
}
$sFtan = \bin\SecureTokens::getFTAN();
$TEXT['BACKUP'] = $TEXT['IMPORT'];
$sql  = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_form_fields` '
      . 'WHERE `section_id` = '.(int)$section_id.' '
      . '';
if (!$backupType = $database->get_one($sql)==0){
    $TEXT['BACKUP'] = $TEXT['EXPORT'];
}
$sSectionIDKEY = $admin->getIDKEY($section_id);

?>
  <div id="FrmModal<?php echo $section_id;?>" class="modalFrmDialog w3-modal w3-animate-opacity">
    <div class="w3-modal-content w3-card-4 ">
      <header class="w3-container w3-header-blue-wb">
        <span class="w3-button w3-circle w3-xlarge w3-red w3-display-topright w3-close" style="top: -10px; right: -10px;">X</span>
        <p class="w3-large"><?php echo $oLang->FORM_MESSAGE_DELETE_LAYOUT;?></p>
      </header>
          <div class="w3-center w3-container w3-padding-32 ">
              <p id="message<?php echo $section_id;?>" class="w3-panel w3-large w3-text-red w3-margin"><?php echo $oLang->FORM_MESSAGE_CONFIRM_DELETE_LAYOUT;?> Section </p>
              <form action="<?php echo $ModuleUrl; ?>modify_backup.php" method="post">
                  <input type="hidden" value="<?php echo $page_id; ?>" name="page_id">
                  <input id="p<?php echo $section_id; ?>" type="hidden" value="<?php echo $sSectionIDKEY; ?>" name="frm_id">
                  <input type="hidden" value="<?php echo $sFtan['value'];?>" name="<?php echo $sFtan['name'];?>">
                  <button name="delete_all" type="submit" class="btn w3-blue-wb w3-round w3-hover-green w3-medium "><?php echo $oLang->FORM_MESSAGE_DELETE_FIELDS;?></button>
                  <button type="reset" class="btn w3-blue-wb w3-round w3-hover-red w3-medium w3-close" ><?php echo $oLang->TEXT_CLOSE;?></button>
              </form>
          </div>
      <footer class="w3-container w3-header-blue-wb">
        <p>&nbsp;</p>
      </footer>
    </div>
  </div>

<table class="mod_form" style="width: 100%;">
    <tbody>
        <tr>
            <td style="width: 33.336%;">
                <form action="<?php echo $ModuleUrl; ?>add_field.php" method="post" class="mod_form" >
                    <input type="hidden" value="<?php echo $page_id; ?>" name="page_id">
                    <input type="hidden" value="<?php echo $section_id; ?>" name="section_id">
                    <input type="hidden" value="<?php echo $sFtan['value'];?>" name="<?php echo $sFtan['name'];?>">
                    <input type="submit" value="<?php echo $TEXT['ADD_FIELD']; ?>" class="btn btn-default w3-blue-wb w3-round w3-hover-green w3-medium w3-padding-4" style="width: 100%;" />
                </form>
            </td>
<?php       if ($bCanBackup){ ?>
            <td style="width: 33.336%;">
                <form action="<?php echo $ModuleUrl; ?>modify_backup.php" method="post" class="mod_form" >
                    <input type="hidden" value="<?php echo $page_id; ?>" name="page_id">
                    <input type="hidden" value="<?php echo $section_id; ?>" name="section_id">
                    <input type="hidden" value="<?php echo $sSectionIDKEY; ?>" name="frm_id">
                    <input type="hidden" value="<?php echo $sFtan['value'];?>" name="<?php echo $sFtan['name'];?>">
                    <input type="submit" value="<?php echo $TEXT['BACKUP']; ?>" class="btn btn-default w3-blue-wb w3-round w3-hover-green w3-medium w3-padding-4" style="width: 100%;" />
                </form>
            </td>
<?php       }
            if ($bCanModifyOption) {
?>
            <td style="width: 33.336%;">
                <form action="<?php echo $ModuleUrl; ?>modify_settings.php" method="post" class="mod_form" >
                    <input type="hidden" value="<?php echo $page_id; ?>" name="page_id">
                    <input type="hidden" value="<?php echo $section_id; ?>" name="section_id">
                    <input type="hidden" value="<?php echo $sFtan['value'];?>" name="<?php echo $sFtan['name'];?>">
                    <input type="submit" value="<?php echo $TEXT['SETTINGS']; ?>" class="btn btn-default w3-blue-wb w3-round w3-hover-green w3-medium w3-padding-4" style="width: 100%;" />
                </form>
            </td>
<?php       } ?>
<?php if(@DEBUG && $admin->ami_group_member('1')) { ?>
            <td style="width: 33.336%;">
                <form action="<?php echo $ModuleUrl; ?>/modules/form/reorgPosition.php" method="post" class="mod_form" >
                    <input type="hidden" value="<?php echo $page_id; ?>" name="page_id">
                    <input type="hidden" value="<?php echo $section_id; ?>" name="section_id">
                    <input type="hidden" value="<?php echo $sFtan['value'];?>" name="<?php echo $sFtan['name'];?>">
                    <input type="submit" value="Reorg Position" class="btn btn-default w3-blue-wb w3-round w3-hover-green w3-medium w3-padding-4" style="width: 100%;" />
                </form>
            </td>
<?php } ?>
        </tr>
    </tbody>
</table>

<p id="tablecontent<?php echo $section_id;?>" class="tablecontent"></p>
<div class="jsadmin hide"></div>
<?php
// Loop through existing fields
$sql  = 'SELECT * FROM `'.TABLE_PREFIX.'mod_form_fields` '
      . 'WHERE `section_id` = '.(int)$section_id.' '
      . 'ORDER BY `position` ASC';
if($oFields = $database->query($sql)) {
    $num_fields = $oFields->numRows();
    if ($num_fields) {

      ?>

        <div class="w3-bar w3-text-blue-wb w3-xlarge w3-margin">
            <div class="w3-col m12 w3-container w3-padding">
                    <span class="w3-text-blue-wb"><?php echo $TEXT['MODIFY_DELETE_FIELD']; ?></span>
                    <span class="w3-right">
<?php if ($bCanDelete) { ?>
                        <button id="<?php echo $section_id;?>_section" class="field_delete btn w3-blue-wb w3-round w3-hover-green w3-medium w3-padding-4 "><?php echo $oLang->FORM_MESSAGE_DELETE_LAYOUT;?></button>
<?php } ?>
                    </span>
                </div>
        </div>
        <table class="mod_form w3-table-all" id="tableData<?php echo $section_id;?>" >
            <thead>
                <tr class="w3-header-blue-wb">
                    <th style="padding-left: 5px; width: 3%;" >&nbsp;</th>
                    <th style="text-align: right; width: 3%;" >ID</th>
                    <th style=" width: 50%;" ><?php print $TEXT['FIELD']; ?></th>
                    <th style=" width: 20%;" ><?php print $TEXT['TYPE']; ?></th>
                    <th style=" width: 5%;" ><?php print $TEXT['REQUIRED']; ?></th>
                    <th style=" width: 5%;" >
                    <?php
                        echo $TEXT['MULTISELECT'];
                    ?>
                    </th>
                    <th style=" width: 10%;" colspan="3" >
                    <?php
                        echo $TEXT['ACTIONS'];
                    ?></th>
                    <th style=" width: 3%;" >POS</th>
                </tr>
            </thead>
            <tbody>
<?php
        while($aFields = $oFields->fetchRow(MYSQLI_ASSOC)) {
          $sFieldIdkey = $admin->getIDKEY($aFields['field_id']);
?><tr class=" sectionrow">
                <td style="padding-left: 5px;">
                    <a href="<?php echo $ModuleUrl; ?>modify_field.php?page_id=<?php echo $page_id; ?>&amp;section_id=<?php echo $section_id; ?>&amp;field_id=<?php echo $sFieldIdkey; ?>" title="<?php echo $TEXT['MODIFY']; ?>">
                        <img src="<?php echo THEME_URL; ?>/images/modify_16.png" alt="^" />
                    </a>
                </td>
                <td style="text-align: right;">
                    <a style=" font-weight: normal;" href="<?php echo $ModuleUrl; ?>modify_field.php?page_id=<?php echo $page_id; ?>&amp;section_id=<?php echo $section_id; ?>&amp;field_id=<?php echo $sFieldIdkey; ?>">
                        <?php echo $aFields['field_id']; ?>
                    </a>
                </td>
                <td>
                    <a href="<?php echo $ModuleUrl; ?>modify_field.php?page_id=<?php echo $page_id; ?>&amp;section_id=<?php echo $section_id; ?>&amp;field_id=<?php echo $sFieldIdkey; ?>">
                        <?php echo $aFields['title']; ?>
                    </a>
                </td>
                <td>
<?php
                    $key = $aFields['type'];
                    switch ($key):
                        case 'textfield':
                            $sTitle = $TEXT['SHORT_TEXT'];
                            break;
                        case 'textarea':
                            $sTitle = $TEXT['LONG_TEXT'];
                            break;
                        case 'heading':
                            $sTitle = $TEXT['HEADING'];
                            break;
                        case 'select':
                            $sTitle = $TEXT['SELECT_BOX'];
                            break;
                        case 'checkbox':
                            $sTitle = $TEXT['CHECKBOX_GROUP'];
                            break;
                        case 'radio':
                            $sTitle = $TEXT['RADIO_BUTTON_GROUP'];
                            break;
                        case 'email':
                            $sTitle = $TEXT['EMAIL_ADDRESS'];
                            break;
                        default:
                        break;
                    endswitch;
                    echo $sTitle;
?></td>
                <td style="text-align: center;">
<?php
                if ($aFields['type'] != 'group_begin') {
                    if($aFields['required'] == 1) { echo $TEXT['YES']; } else { echo $TEXT['NO']; }
                }
?>
                </td>
                <td>
<?php
                if ($aFields['type'] == 'select') {
                    $aFields['extra'] = \explode(',',$aFields['extra']);
                     if($aFields['extra'][1] == 'multiple') { echo $TEXT['YES']; } else { echo $TEXT['NO']; }
                }
?>
                </td>
                <td style="text-align: center;">
<?php if($aFields['position'] != 1) { ?>
                    <a href="<?php echo $ModuleUrl; ?>move_up.php?page_id=<?php echo $page_id; ?>&amp;section_id=<?php echo $section_id; ?>&amp;field_id=<?php echo $sFieldIdkey; ?>&amp;move_id=<?php echo $aFields['field_id']; ?>&amp;position=<?php echo $aFields['position']; ?>&amp;module=<?php echo $sModulName; ?>" title="<?php echo $TEXT['MOVE_UP']; ?>">
                        <img src="<?php echo THEME_URL; ?>/images/up_16.png" alt="up" />
                    </a>
<?php } ?>
                </td>
                <td  style="text-align: center;">
<?php if($aFields['position'] != $num_fields) { ?>
                    <a href="<?php echo $ModuleUrl; ?>move_down.php?page_id=<?php echo $page_id; ?>&amp;section_id=<?php echo $section_id; ?>&amp;field_id=<?php echo $sFieldIdkey; ?>&amp;move_id=<?php echo $aFields['field_id']; ?>&amp;position=<?php echo $aFields['position']; ?>&amp;module=<?php echo $sModulName; ?>" title="<?php echo $TEXT['MOVE_DOWN']; ?>">
                        <img src="<?php echo THEME_URL; ?>/images/down_16.png" alt="down" />
                    </a>
<?php } ?>
                </td>
                <td style="text-align: center;">
<?php
                $url = ($ModuleUrl.'delete_field.php?page_id='.$page_id.'&amp;section_id='.$section_id.'&amp;field_id='.$sFieldIdkey)
?>
                    <a class="confirm" onclick="confirm_link('<?php echo \url_encode($TEXT['ARE_YOU_SURE']); ?>','<?php echo $url; ?>');" title="<?php echo $TEXT['DELETE']; ?>">
                        <img src="<?php echo THEME_URL; ?>/images/delete_16.png" alt="X" />
                    </a>
                </td>
                <td style="text-align: right; padding-right: 5px;">
<?php
                    echo $aFields['position'];
if ( DEBUG ) {
}
?>
                </td>
            </tr>
<?php
            // Alternate row color
        } // end while fields
?>
        </tbody>
        </table>

<?php
        // include the required file for Javascript admin
        if (\file_exists(WB_PATH.'/modules/jsadmin/jsadmin_backend_include.php')) {
            include(WB_PATH.'/modules/jsadmin/jsadmin_backend_include.php');
        }
    } else { ?>
        <div class=" w3-text-blue-wb w3-large w3-margin"><?php echo $TEXT['FORM_NONE_FOUND'];?></div>
<?php
    }
}

?>
<div class="w3-container">

<div class="w3-bar w3-text-blue-wb w3-xlarge w3-margin">
    <div class="w3-col m12 w3-container">
            <span class="w3-text-blue-wb"><?php echo $TEXT['SUBMISSIONS']; ?></span>
        </div>
</div>

<?php
$old_section_id = $section_id;
// Query submissions table
/*
$sql  = 'SELECT * FROM `'.TABLE_PREFIX.'mod_form_submissions`  ';
$sql .= 'WHERE `section_id` = '.(int)$section_id.' ';
$sql .= 'ORDER BY `submitted_when` ASC ';
*/
$sql  = 'SELECT s.*, u.`display_name`, u.`email` ';
$sql .=            'FROM `'.TABLE_PREFIX.'mod_form_submissions` s ';
$sql .= 'LEFT OUTER JOIN `'.TABLE_PREFIX.'users` u ';
$sql .= 'ON u.`user_id` = s.`submitted_by` ';
$sql .= 'WHERE s.`section_id` = '.(int)$section_id.' ';
$sql .=   'AND s.`body` != \'\' ';
$sql .= 'ORDER BY s.`submitted_when` DESC ';

if($oSubmissions = $database->query($sql)) {
?>
<!-- submissions -->
    <div class="frm-ScrollTableDiv">
        <table id="frm-ScrollTable<?php echo $section_id;?>" class="w3-table-all">
            <thead class="frm-Scroll w3-header-blue-wb">
                <tr id="frm-Scroll<?php echo $section_id;?>" class="w3-header-blue-wb">
                    <th style="text-align: center; width: 1%;">&nbsp;</th>
                    <th style="text-align: center; width: 2%;"> ID </th>
                    <th style=" width: 12%;"><?php echo $TEXT['SUBMITTED'] ?></th>
                    <th style=" width: 19%;"><?php echo $TEXT['USER']; ?></th>
                    <th style=" width: 12%;"><?php echo $TEXT['EMAIL'].' '.$MOD_FORM['FROM'] ?></th>
                    <th style="text-align: center; width: 5%;">&nbsp;</th>
                    <th style="text-align: center; width: 5%;">&nbsp;</th>
                    <th style="text-align: center; width: 3%;">&nbsp;</th>
                    <th style="text-align: center; width: 3%;">&nbsp;</th>
                </tr>
            </thead>
        <tbody class="scrolling">
<?php
    if($oSubmissions->numRows() > 0) {
        // List submissions
       $emailUser = (function ($userid=0) use ($database)
       {
            $retval = '';
            if ($userid!='0') {
                $sql  = 'SELECT `email` FROM `'.TABLE_PREFIX.'users` '
                      . 'WHERE `user_id`=\' '.$userid.'\' ';
                $retval = $database->get_one($sql);
            }
            return $retval;
        });
        while($submission = $oSubmissions->fetchRow(MYSQLI_ASSOC)) {
            $submission['display_name'] = (($submission['display_name']!=null) ? $submission['display_name'] : $TEXT['GUEST']);
            $sBody = $submission['body'];
            $submission['email'] = $emailUser($submission['submitted_by']);
            if ($submission['email']==''){
                $regex = "/[a-z0-9\-_]?[a-z0-9.\-_]+[a-z0-9\-_]?@[a-z0-9.-]+\.[a-z]{2,}/i";
                \preg_match ($regex, $sBody, $output);
// workout if output is empty
                $submission['email'] = (isset($output['0']) ? $output['0'] : '');
            }
            $sSubmissionIdkey = $admin->getIDKEY($submission['submission_id']);
?>
            <tr class="frm-Scroll" >
                <td class="frm-Scroll" style="text-align: center; width: 3%;">
                    <a href="<?php echo WB_URL; ?>/modules/form/view_submission.php?page_id=<?php echo $page_id; ?>&amp;section_id=<?php echo $section_id; ?>&amp;submission_id=<?php echo $sSubmissionIdkey; ?>" title="<?php echo $TEXT['OPEN']; ?>">
                        <img src="<?php echo THEME_URL; ?>/images/folder_16.png" alt="<?php echo $TEXT['OPEN']; ?>" />
                    </a>
                </td>
                <td class="frm-Scroll" style="padding-right: 15px;text-align: right; width: 3%; font-weight: normal;"><?php echo $submission['submission_id']; ?></td>
                <td class="frm-Scroll" style=" width: 22%;"><?php echo gmdate(DATE_FORMAT.', '.TIME_FORMAT, $submission['submitted_when']+TIMEZONE ); ?></td>
                <td class="frm-Scroll" style=" width: 33%;"><?php echo $submission['display_name']; ?></td>
                <td class="frm-Scroll" style=" width: 30%;" ><?php echo $submission['email']; ?></td>
                <td class="frm-Scroll" style="text-align: center; width: 5%;">&nbsp;</td>
                <td class="frm-Scroll" style=" width: 5%;"  >&nbsp;</td>
                <td class="frm-Scroll"  style="text-align: center; width: 5%;">
<?php
                $url = (WB_URL.'/modules/form/delete_submission.php?page_id='.$page_id.'&amp;section_id='.$section_id.'&amp;submission_id='.$sSubmissionIdkey)
?>
                    <a class="confirm" onclick="confirm_link('<?php echo \url_encode($TEXT['ARE_YOU_SURE']); ?>', '<?php echo $url; ?>');" title="<?php echo $TEXT['DELETE']; ?>">
                        <img src="<?php echo THEME_URL; ?>/images/delete_16.png" alt="X" />
                    </a>
                </td>
<?php
if ( DEBUG ) { ?>
                <td class="frm-Scroll" style=" width: 3%;" ><?php echo $sSubmissionIdkey; ?></td>
<?php } else  { ?>
                <td class="frm-Scroll" style=" width: 3%;" >&nbsp;</td>
<?php }  ?>
            </tr>
<?php
        }
    } else { ?>
<tr class="w3-section"><td colspan="9" class=" w3-text-blue-wb w3-large w3-margin"><?php echo $TEXT['FORM_NONE_FOUND'] ?></td></tr>
<?php } ?>
        </tbody>
        </table><br />
    </div>
<?php
} else {
    echo $database->get_error().'<br />';
    echo $sql;
}

?>

</div>
