<?php
/**
 *
 * @category        modules
 * @package         form
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.x
 * @requirements    PHP 5.6 and higher
 * @version         $Id: modify_backup.php 284 2019-03-22 08:13:16Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/form/modify_backup.php $
 * @lastmodified    $Date: 2019-03-22 09:13:16 +0100 (Fr, 22. Mrz 2019) $
 * @since           File available since  2017 sept 21
 * @description     xyz
 */
/* -------------------------------------------------------- */
if ( !defined( 'WB_PATH' ) ){ require( dirname(dirname((__DIR__))).'/config.php' ); }

$sAddonPath = (__DIR__);
$sAddonName = basename($sAddonPath);
$sTargetPath  = $sAddonPath.'/data/fields/';
$aMessage = [];

$print_info_banner = true;
// suppress to print the header, so no new FTAN will be set
$admin_header = true;
// Tells script to update when this page was last updated
$update_when_modified = true;
// Include WB admin wrapper script
require(WB_PATH.'/modules/admin.php');
// An associative array that by default contains the contents of $aRequestVars, $aRequestVars and $_COOKIE.
$requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
$aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);
$sSectionIdPrefix = (defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' );

$removeExtension = (function ($sFilename){
    $sRetval = '';
    return preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', $sFilename);
});

$sAddonThemePath= $sAddonPath.'/themes/default/';
//$backUrl = ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'#'.$sSectionIdPrefix.$section_id;
$backUrl = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;
$backModuleUrl = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;
$sBackLink = (isset($_POST['save_close'])?$backUrl:$backModuleUrl).'';

$oLang = Translate::getInstance();
$oLang->enableAddon('modules\\'.basename(__DIR__));
$aLang = $oLang->getLangArray();

if (defined('DEBUG')&& (DEBUG==true)&& $admin->ami_group_member('1')){
}

// Get id
$section_id = intval($admin->checkIDKEY('frm_id', false,$requestMethod));

if (!$section_id) {
//    $admin_header = false;
    $admin->print_error( $MESSAGE['GENERIC_SECURITY_ACCESS'].'', $backUrl );
}
$action = 'show';
$action = (isset($aRequestVars['cancel'])?'cancel':$action);
$action = (isset($aRequestVars['delete_all'])?'delete_all':$action);

      switch ($action):
          case 'delete_all':
              $sql  = 'DELETE FROM `'.TABLE_PREFIX.'mod_form_fields` '
                    . 'WHERE `section_id` = '.(int)$section_id.' ';
              if(!$oFields = $database->query($sql)) {
                  $admin->print_error( $database->get_error(), $backUrl );
              } else {
                  $admin->print_success( $oLang->FORM_MESSAGE_ALL_DELETED.'', $backUrl );
              }
              break;
          default:
              $tpl = new \vendor\phplib\Template($sAddonThemePath);
              $tpl->set_file('page', 'field_backup.htt');
              $tpl->set_block('page', 'main_block', 'main');
              $tpl->set_block('main_block', 'show_export_block', 'show_export');
              $tpl->set_var($aLang);
              $tpl->set_var(
                    array(
                        'MODULE_URL' => WB_URL.'/modules/'.$sAddonName,
                        'ADMIN_URL' => ADMIN_URL,
                        'PAGE_ID' => $page_id,
                        'SECTION_ID' => $section_id,
//                        'SECT_ID' => $admin->getIDKEY($section_id),
                        'FTAN' => $admin->getFTAN(),
                        'FILENAME' => 'FieldMap',
                        'SECTIONID_PREFIX' => $sSectionIdPrefix.$section_id,
                        #
                    ));
              $tpl->set_var('TYPE','export');
              $tpl->set_var($aLang);
              $tpl->set_block('main_block', 'show_import_block', 'show_import');
              $tpl->set_block('show_import_block', 'show_input_import_block', 'show_input_import');
              $tpl->set_block('show_import_block', 'show_upload_import_block', 'show_upload_import');
              $aImportFiles = glob($sTargetPath.'*.xml', GLOB_NOSORT);
              sort($aImportFiles);
              if (sizeof($aImportFiles)){
                  $tpl->set_block('show_import_block', 'file_list_block', 'file_list');
                  foreach ($aImportFiles as $sFilename){
                      $tpl->set_var('IMPORT_FILENAME', (basename($sFilename)));
                      $tpl->set_var('IMPORT_FILE', $removeExtension(basename($sFilename)));
                      $tpl->parse('file_list', 'file_list_block', true);
                  }
                  $tpl->parse('show_import', 'show_import_block', true);
              } else {
                  $tpl->set_block('show_import', '');
              }
              $sql  = 'SELECT COUNT(*) FROM `'.TABLE_PREFIX.'mod_form_fields` '
                    . 'WHERE `section_id` = '.(int)$section_id.' '
                    . '';
              if ($database->get_one($sql)==0){
                  $tpl->set_block('show_export', '');
                  $tpl->parse('show_input_import', 'show_input_import_block', true);
                  $tpl->parse('show_upload_import', 'show_upload_import_block', true);
                  $tpl->set_var('TYPE','import');
              } else {
                  $tpl->set_var('TYPE','export');
                  $tpl->parse('show_export', 'show_export_block', true);
              }
              $tpl->parse('main', 'main_block', false);
              $tpl->pparse('output', 'page');
      endswitch;

// Print admin footer
    $admin->print_footer();
