<?php
/**
 *
 * @category        modules
 * @package         form
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.x
 * @requirements    PHP 5.6 and higher
 * @version         $Id: modify_settings.php 341 2019-04-27 14:40:31Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/form/modify_settings.php $
 * @lastmodified    $Date: 2019-04-27 16:40:31 +0200 (Sa, 27. Apr 2019) $
 * @description
 */

if (!defined('SYSTEM_RUN') ){ require( dirname(dirname((__DIR__))).'/config.php' );}
if (!ini_get('arg_separator.output')!='&') { ini_set('arg_separator.output', '&'); }
// Create new frontend object

if (!isset($wb) || !($wb instanceof wb)) { $wb = new wb(); }

$print_info_banner = true;
// Tells script to update when this page was last updated
$update_when_modified = false;
// Include WB admin wrapper script
require(WB_PATH.'/modules/admin.php');

$sAddonName   = basename(__DIR__);

$ModuleRel    = '/modules/'.$sAddonName;
$ModuleUrl    = WB_URL.$ModuleRel;
$ModulePath   = WB_PATH.$ModuleRel;

$sAddonRel    = '/modules/'.$sAddonName;
$sAddonUrl    = WB_URL.$sAddonRel;
$sAddonPath   = WB_PATH.$sAddonRel;
$sTargetPath  = $sAddonPath.'/data/layouts/';
$bCanBackup   = ($admin->ami_group_member('1') ||
                $admin->get_permission('settings') ||
                $admin->get_permission('admin_tools')); // true false

$aCaptchaAction = ['all','image','image_iframe','input','text']; // feature settings
$aCaptchaAction = ['all'];

$requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
$aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

$sQueryStr = $_SERVER['QUERY_STRING'];
$sArgSeperator = ini_get('arg_separator.output');
$aQueryStr = explode($sArgSeperator, $sQueryStr);

// include core functions of WB 2.7 to edit the optional module CSS files (frontend.css, backend.css)
if (!function_exists('edit_module_css')) {include(WB_PATH .'/framework/module.functions.php');}

#$MediaTools = \media\ParentList::getInstance();
// load module language file
//$sAddonName = basename(__DIR__);
if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

$sSelect    = ' selected="selected"';
$sSectionIdPrefix = (defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' );
$sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;
/* */
if (!$admin->checkFTAN($requestMethod)){
    $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $sBacklink.'#'.$sSectionIdPrefix.$section_id);
}

   $emailAdmin = (function () use ( $database, $wb )
   {
        $retval = $wb->get_email();
        if($wb->get_user_id()!='1') {
            $sql  = 'SELECT `email` FROM `'.TABLE_PREFIX.'users` '
                  . 'WHERE `user_id`=\'1\' ';
            $retval = $database->get_one($sql);
        }
        return $retval;
    });

$removeExtension = (function ($sFilename){
    return preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', $sFilename);
});

// Get Settings from DB $aSettings['
$sql  = 'SELECT * FROM `'.TABLE_PREFIX.'mod_form_settings` '
      . 'WHERE `section_id` = '.(int)$section_id.'';
if($oSetting = $database->query($sql)) {
    $aSettings = $oSetting->fetchRow(MYSQLI_ASSOC);

    $aSettings['email_to'] = ( ($aSettings['email_to'] != '') ? $aSettings['email_to'] : $emailAdmin());
    $aSettings['email_subject'] = ( ($aSettings['email_subject']  != '') ? $aSettings['email_subject'] : '' );
    $aSettings['success_email_subject'] = ($aSettings['success_email_subject']  != '') ? $aSettings['success_email_subject'] : '';
    $aSettings['success_email_from'] = $admin->add_slashes(SERVER_EMAIL);
    $aSettings['success_email_fromname'] = ($aSettings['success_email_fromname'] != '' ? $aSettings['success_email_fromname'] : WBMAILER_DEFAULT_SENDERNAME);
    $aSettings['success_email_subject'] = ($aSettings['success_email_subject']  != '') ? $aSettings['success_email_subject'] : '';
    $target_section_id = $aSettings['data_protection_link'];

} else {
    $admin->print_error($database->get_error(), $sBacklink);
}
// Set raw html <'s and >'s to be replace by friendly html code
$raw = array('<', '>');
$friendly = array('&lt;', '&gt;');

$sLayoutTitle = '';
$cLayoutTitle = '';
$sLayoutDescription = '';
// overwrite settings
if (isset($aRequestVars['install_layout'])) {
    if (is_readable(__DIR__.'/data/layouts/Default_Layout.inc.php')){require (__DIR__.'/data/layouts/Default_Layout.inc.php');}
    foreach ($aSettings as $sKey=>$sValue){
      if (!isset(${$sKey})) {continue;}
      $aSettings[$sKey] = ${$sKey};
    }
} else {
  $sAbsFilename = __DIR__.'/data/layouts/'.$aSettings['layout'].'.xml';

  if (is_readable($sAbsFilename)&& ($oXml = simplexml_load_file($sAbsFilename))) {
      $sLayoutTitle = $oXml->title;
      $sLayoutDescription = $oXml->description;
  }
}
$cLayoutTitle = (trim($sLayoutTitle) ? ' - '.$sLayoutTitle : '');
$FTAN  = $admin->getFTAN('');
$sFtan = $FTAN['name'].'='.$FTAN['value'];

$aImportFiles = glob($sTargetPath.'*.xml', GLOB_NOSORT);
sort($aImportFiles);

$aSelectPages = [];
$aSelectPages = \bin\helpers\ParentList::menulink_make_tree(0, $aSelectPages);

if ($print_info_banner) {
?>
    </div><!--end class="block-outer" -->
<?php } ?>
    <?php
    // include the button to edit the optional module CSS files
    // Note: CSS styles for the button are defined in backend.css (div class="mod_moduledirectory_edit_css")
    // Place this call outside of any <form></form> construct!!!
    ?>
    <div class="w3-padding w3-row">
      <div class="w3-container w3-col m6">
        <h2><?php echo $MOD_FORM['SETTINGS']; ?></h2>
      </div>
      <div class="w3-container w3-col m3 w3-margin-top">
          <form action="<?php echo $ModuleUrl; ?>/modify_settings.php" method="get" >
              <input type="hidden" value="<?php echo $page_id; ?>" name="page_id">
              <input type="hidden" value="<?php echo $section_id; ?>" name="section_id">
              <input type="hidden" value="<?php echo $FTAN['value'];?>" name="<?php echo $FTAN['name'];?>">
              <input type="submit" name="install_layout" value="<?php echo $MOD_FORM['LOAD_LAYOUT']; ?>" class="btn btn-default w3-blue-wb w3-round-small w3-hover-green w3-padding-4" />
          </form>
      </div>

<div class="w3-container w3-col m3 w3-margin-top">
    <?php
    if(function_exists('edit_module_css')){ edit_module_css($sAddonName);}
    ?>
    </div>
<form name="edit" action="<?php echo $ModuleUrl; ?>/save_settings.php" method="post">
    <input type="hidden" name="page_id" value="<?php echo $page_id; ?>" />
    <input type="hidden" name="section_id" value="<?php echo $section_id; ?>" />
    <input type="hidden" name="success_email_to" value="" />
    <input type="hidden" name="cmd" value="" />

    <?php echo $admin->getFTAN(); ?>
    <div class="block-outer">
        <table class="form w3-table">
            <caption class="form-header w3-header-blue-wb"><?php echo $HEADING['GENERAL_SETTINGS']; ?></caption>
            <tbody>
            <tr>
                <td class="frm-setting_name"><?php echo $TEXT['CAPTCHA_VERIFICATION']; ?>:</td>
                <td>
                    <input onclick="w3.show('#captcha-info')" class="w3-radio" type="radio" name="use_captcha" id="use_captcha_true" value="1"<?php if($aSettings['use_captcha'] == true) { echo ' checked="checked"'; } ?> />
                    <label for="use_captcha_true"><?php echo $TEXT['ENABLED']; ?></label>
                    <input onclick="w3.hide('#captcha-info')" class="w3-radio" type="radio" name="use_captcha" id="use_captcha_false" value="0"<?php if($aSettings['use_captcha'] == false) { echo ' checked="checked"'; } ?> />
                    <label for="use_captcha_false"><?php echo $TEXT['DISABLED']; ?></label>
                </td>
            </tr>

            <tr id="captcha-info" <?php echo ($aSettings['use_captcha'] ? '' : 'style="display: none"'); ?> >
                <td colspan="2">
                   <div class="w3-panel w3-leftbar w3-light-grey" style="padding-bottom: 1.25em;">
                   <h5><?php echo $MOD_FORM['CAPTCHA_PLACEHOLDER'];?></h5>
                    <code class="w3-codespan">
                    {CALL_CAPTCHA}
                    </code>
                  </div>
                 </td>
            </tr>
<?php ?>
            <tr>
                <td class="frm-setting_name"><?php echo $FORM_MESSAGE['CAPTCHA_STYLE']; ?>:</td>
                <td>
                    <input class="w3-input" style="width: 98%;" type="text" name="captcha_style" value="<?php echo str_replace($raw, $friendly, ($aSettings['captcha_style'])); ?>" />
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $FORM_MESSAGE['CAPTCHA_ACTION']; ?>:</td>
                <td>
                    <select class="w3-select" style="width: 98%;" name="captcha_action">
<?php
                    foreach ($aCaptchaAction as $sAction) {
                      $selected = (($sAction==$aSettings['captcha_action'])?' selected="selected"':'')
?>
                        <option value="<?php echo $sAction;?>"<?php echo $selected;?>><?php echo $sAction.' => '.$FORM_MESSAGE[strtoupper($sAction)];?></option>
<?php
                    }?>
                    </select>
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $TEXT['MAX_SUBMISSIONS_PER_HOUR']; ?>:</td>
                <td>
                    <input class="w3-check" type="text" name="max_submissions" style="width: 30px;" value="<?php echo str_replace($raw, $friendly, ($aSettings['max_submissions'])); ?>" />
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $TEXT['SUBMISSIONS_STORED_IN_DATABASE']; ?>:</td>
                <td>
                    <input class="w3-check" type="text" name="stored_submissions" style="width: 30px;" value="<?php echo str_replace($raw, $friendly, ($aSettings['stored_submissions'])); ?>" />
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $TEXT['SUBMISSIONS_PERPAGE']; ?>:</td>
                <td>
                    <input class="w3-check" type="text" name="perpage_submissions" style="width: 30px;" value="<?php echo str_replace($raw, $friendly, ($aSettings['perpage_submissions'])); ?>" />
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name w3-right-align"><?php echo $TEXT['SUCCESS'].' '.$TEXT['PAGE']; ?>:</td>
                <td class="frm-newsection">
                    <select class="w3-select" name="success_page" style="width: 98%;">
                    <option class="level" value=""><?php echo $TEXT['NONE']; ?></option>
<?php
              foreach( $aSelectPages as $iKey=> $aValue ) {
                  $sPrefix = str_repeat(' -- ', $aValue['level']);
                  $sSelected = (($iKey==$aSettings['success_page']) ? ' selected="selected"' : '');
?>
                            <option class="level<?php echo $aValue['level'];?>" value="<?php echo $iKey;?>" <?php echo $sSelected;?>><?php echo $sPrefix.$aValue['menu_title'];?></option>
<?php  }?>
                        </select>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>

<?php if ($bCanBackup) {;?>
    <div class="block-outer">
        <table class="form w3-table">
              <caption class="form-header w3-header-blue-wb"><?php echo $FORM_MESSAGE['LAYOUT_SETTINGS']; ?></caption>
<?php
          if (sizeof($aImportFiles)){
?>
            <tr>
                <td colspan="2">
                   <div class="w3-panel w3-leftbar w3-light-grey">
                    <p class="w3-large w3-serif">
                   <i class="w3-border-0"><b class="w3-text-red w3-xlarge">&#160;</b> Layout title and description will be add only to the xml file!</i></p>
                  </div>
                 </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $FORM_MESSAGE['LAYOUT_TITLE']; ?></td>
                <td>
                    <div class="w3-row">
                        <div class="w3-col m12 w3-nav-bar">
                            <div class="w3-col m4 w3-padding-2">
                                <select id="layout" class="w3-select" style="vertical-align: top;" name="file">
                                    <option value=""><?php print $FORM_MESSAGE['TEXT_SELECT_BOX'] ?></option>
<?php
foreach ($aImportFiles  as $sFilename) {
    $sSelected = (basename($sFilename)==$aSettings['layout'].'.xml') ? ' selected="selected"' : '';
?>
                                   <option value="<?php print basename($sFilename); ?>"<?php echo $sSelected; ?> ><?php print $removeExtension(basename($sFilename)); ?></option>
<?php } ?>
                                </select>
                            </div>
                            <div class="w3-col m2 w3-center w3-padding-2">
                                <button type="submit" class="w3-input w3-blue-wb w3-round w3-hover-green w3-pointer" name="import" formaction="<?php echo $sAddonUrl;?>/layout_import.php" ><?php echo $TEXT['IMPORT'];?></button>
                            </div>
                            <div class="w3-col m2 w3-center w3-padding-2">
                                <button id="download_xml" class="w3-input w3-blue-wb w3-round w3-hover-green w3-pointer" type="application/rss+xml" formaction="<?php echo $sAddonUrl;?>/layout_download.php"><?php echo $FORM_MESSAGE ['DOWNLOAD'];?></button>
                            </div>
                            <div class="w3-col m2 w3-center w3-padding-2">
                                <input class="w3-input w3-blue-wb w3-round w3-hover-red w3-pointer" name="delete" type="submit" formaction="<?php echo $sAddonUrl;?>/layout_import.php" value="<?php echo $TEXT['DELETE'];?>"/>
                            </div>
                            <div class="w3-col m2 w3-center w3-padding-2">
                                <input class="w3-input w3-blue-wb w3-round w3-hover-red w3-pointer" type="button" value="<?php echo $TEXT['BACK'];?>" onclick="window.location.href='<?php echo $sBacklink.'#'.$sSectionIdPrefix.$section_id;?>'" />
                            </div>
                        </div>
                  </div>
                </td>
            </tr>
            <?php } ?>
            <tr>
                <td class="frm-setting_name"><?php echo $FORM_MESSAGE['LAYOUT_TITLE_NEW']; ?>:</td>
                <td>
                    <div class="w3-row">
                        <div class="w3-col m12 w3-nav-bar">
                            <div class="w3-col m4 w3-padding-2">
                                <input id="LayoutTitle" class="w3-input w3-border" type="text" name="title" value="<?php echo $sLayoutTitle;?>" />
                            </div>
                            <div class="w3-col m4 w3-center w3-padding-2">
                                <button type="submit" class="w3-input w3-blue-wb w3-round w3-hover-green w3-pointer" name="export" formaction="<?php echo $sAddonUrl;?>/layout_export.php" ><?php echo $TEXT['EXPORT'];?></button>
                            </div>
                        </div>
                  </div>
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $FORM_MESSAGE['LAYOUT_DESCRIPTION']; ?>:</td>
                <td>
                    <div class="w3-col m12 w3-nav-bar">
                        <div class="w3-col m12 w3-padding-2">
                          <textarea id="LayoutDescription" class="w3-textarea w3-border w3-mobile" name="description" cols="1" rows="10" style="width: 98%; height: 120px;"><?php echo $sLayoutDescription;?></textarea>
                        </div>
                    </div>
                </td>
            </tr>
            <tr>
                <td colspan="2">&#160;
                 </td>
            </tr>
            </tbody>
        </table>
    </div>
    <div class="block-outer">
        <table class="form w3-table">
              <caption id="cLayoutTitle" class="form-header w3-header-blue-wb"><?php echo $FORM_MESSAGE['LAYOUT'].$cLayoutTitle; ?></caption>
            <tbody>
            <tr>
                <td class="frm-setting_name"><?php echo $TEXT['HEADER']; ?>:</td>
                <td>
                    <textarea class="w3-textarea w3-border" name="header" cols="1" rows="6" style="width: 98%;"><?php echo ($aSettings['header']); ?></textarea>
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $TEXT['FIELD'].' '.$TEXT['LOOP']; ?>:</td>
                <td>
                    <textarea class="w3-textarea w3-border" name="field_loop" cols="1" rows="5" style="width: 98%;"><?php echo ($aSettings['field_loop']); ?></textarea>
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $TEXT['EXTRA']; ?>:</td>
                <td>
                    <textarea class="w3-textarea w3-border" name="extra" cols="1" rows="10" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSettings['extra'])); ?></textarea>
                </td>
            </tr>
            <tr>
                <td class="frm-setting_name"><?php echo $TEXT['FOOTER']; ?>:</td>
                <td>
                    <textarea class="w3-textarea w3-border" name="footer" cols="1" rows="10" style="width: 98%;"><?php echo str_replace($raw, $friendly, ($aSettings['footer'])); ?></textarea>
                </td>
            </tr>
              <tr><td colspan="2">&#160;</td></tr>
            </tbody>
        </table>
        </div>
        <div class="form block-outer" style="margin-top: 2.225em;">
    <!-- E-Mail Optionen -->
          <table title="<?php echo $TEXT['EMAIL'].' '.$TEXT['SETTINGS']; ?>"  class="form frm-table" style="margin-top: 3px;">
              <caption class="form-header w3-header-blue-wb"><?php echo $TEXT['EMAIL'].' '.$TEXT['SETTINGS']; ?></caption>
              <tbody>
              <tr>
                  <td class="frm-setting_name"><?php echo $TEXT['EMAIL'].' '.$MOD_FORM['TO']; ?>:</td>
                  <td>
                      <input class="w3-input w3-border" type="text" name="email_to" style="width: 98%;" maxlength="255" value="<?php echo str_replace($raw, $friendly, ($aSettings['email_to'])); ?>" />
                  </td>
              </tr>
              <tr>
                  <td class="frm-setting_name"><?php echo $TEXT['DISPLAY_NAME']; ?>:</td>
                  <td>
                      <input class="w3-input w3-border" type="text" name="email_fromname" id="email_fromname" style="width: 98%;" maxlength="255" value="<?php  echo $aSettings['email_fromname'];  ?>" />
                  </td>
              </tr>
              <tr>
                  <td class="frm-setting_name"><?php echo $TEXT['EMAIL'].' '.$TEXT['SUBJECT']; ?>:</td>
                  <td>
                      <input class="w3-input w3-border" type="text" name="email_subject" style="width: 98%;" maxlength="255" value="<?php echo str_replace($raw, $friendly, ($aSettings['email_subject'])); ?>" />
                  </td>
              </tr>
              <tr><td colspan="2">&nbsp;</td></tr>
              </tbody>
          </table>
        </div>
<?php }
?>
        <div class="form block-outer" style="margin-top: 2.225em;">
    <!-- Erfolgreich Optionen -->
            <table class="form w3-table" title="<?php echo $TEXT['EMAIL'].' '.$MOD_FORM['CONFIRM'].' '.$MENU['USERS']; ?>" style="margin-top: 3px;">
                <caption class="form-header w3-header-blue-wb"><?php echo $TEXT['EMAIL'].' '.$MOD_FORM['CONFIRM'].' '.$MENU['USERS']; ?></caption>
                <tbody>
                <tr>
                    <td class="frm-setting_name w3-right-align"><?php echo $TEXT['EMAIL'].' '.$MOD_FORM['TO']; ?>:</td>
                    <td><p class="frm-warning w3-container w3-section w3-pale-red w3-leftbar w3-border-red w3-hover-border-green" style="width: 98%;"><?php echo  $MOD_FORM['RECIPIENT'] ?><br /><?php echo $MOD_FORM['SPAM']; ?> </p>   </td>
                </tr>
                <tr>
                    <td class="frm-setting_name w3-right-align"><?php echo $MOD_FORM['REPLYTO']; ?>:</td>
                    <td>
                        <select class="w3-select" name="success_email_to" style="width: 98%;">
                        <option value="" onclick="javascript: document.getElementById('success_email_to').style.display = 'block';"><?php echo $TEXT['NONE']; ?></option>
<?php
                        $success_email_to = str_replace($raw, $friendly, ($aSettings['success_email_to']));
                        $sql  = 'SELECT `field_id`, `title` FROM `'.TABLE_PREFIX.'mod_form_fields` '
                              . 'WHERE `section_id` = '.(int)$section_id.' '
                              . '  AND  `type` = \'email\' '
                              . 'ORDER BY `position` ASC ';
                        if($query_email_fields = $database->query($sql)) {
                            if($query_email_fields->numRows() > 0) {
                                while($field = $query_email_fields->fetchRow(MYSQLI_ASSOC)) {
?>
                                    <option value="field<?php echo $field['field_id']; ?>"<?php if($success_email_to == 'field'.$field['field_id']) { echo ' selected'; $selected = true; } ?> onclick="javascript: document.getElementById('email_from').style.display = 'none';">
                                        <?php echo $TEXT['FIELD'].': '.$field['title']; ?>
                                    </option>
<?php
                                }
                            }
                        }
?>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td class="frm-setting_name w3-right-align"><?php echo $TEXT['DISPLAY_NAME']; ?>:</td>
                    <td>
                        <?php $aSettings['success_email_fromname'] = ($aSettings['success_email_fromname'] != '' ? $aSettings['success_email_fromname'] : WBMAILER_DEFAULT_SENDERNAME); ?>
                        <input class="w3-input w3-border" type="text" name="success_email_fromname" style="width: 98%;" maxlength="255" value="<?php echo str_replace($raw, $friendly, ($aSettings['success_email_fromname'])); ?>" />
                    </td>
                </tr>
                <tr>
                    <td class="frm-setting_name w3-right-align"><?php echo $TEXT['EMAIL'].' '.$TEXT['SUBJECT']; ?>:</td>
                    <td>
                        <input class="w3-input w3-border" type="text" name="success_email_subject" style="width: 98%;" maxlength="255" value="<?php echo str_replace($raw, $friendly, ($aSettings['success_email_subject'])); ?>" />
                    </td>
                </tr>
                <tr>
                    <td class="frm-setting_name w3-right-align"><?php echo $TEXT['EMAIL'].' '.$TEXT['TEXT']; ?>:</td>
                    <td>
                        <textarea class="w3-textarea w3-border" name="success_email_text" cols="80" rows="1" style="width: 98%; height: 80px;"><?php echo str_replace($raw, $friendly, ($aSettings['success_email_text'])); ?></textarea>
                    </td>
                </tr>
                </tbody>
            </table>
        </div>
        <div class="form block-outer" style="margin-top: 2.225em;">
<?php
    $aSelectSections = [];
    $aSelectSections = \bin\helpers\ParentList::build_sectionlist(0, $page_id, $aSelectSections);
?>
    <!-- DSGVO -->
            <table class="form w3-table" title="<?php echo $TEXT['DSGVO'].' '.$MOD_FORM['CONFIRM']; ?>" style="margin-top: 3px;">
                <caption class="form-header w3-header-blue-wb"><?php echo $TEXT['DSGVO'].' '.$MOD_FORM['CONFIRM']; ?></caption>
                <tbody style="margin-bottom: 0.925em;">
                  <tr>
                     <td class="setting_name"><?php echo $TEXT['DSGVO']; ?></td>
                     <td>
                        <input onclick="w3.show('#data-protection')" type="radio" name="use_data_protection" id="use_data_protection_true" value="1"<?php if ($aSettings['use_data_protection'] == true) { echo ' checked="checked"'; } ?> />
                        <label for="use_data_protection_true"><?php echo $TEXT['ENABLED']; ?></label>
                        <input onclick="w3.hide('#data-protection')" type="radio" name="use_data_protection" id="use_data_protection_false" value="0"<?php if ($aSettings['use_data_protection'] == false) { echo ' checked="checked"'; } ?> />
                        <label for="use_data_protection_false"><?php echo $TEXT['DISABLED']; ?></label>
                     </td>
                  </tr>
                  <tr id="data-protection" <?php echo ($aSettings['use_data_protection'] ? '' : 'style="display: none"'); ?> >
                      <td colspan="2">
                         <div class="w3-panel w3-leftbar w3-light-grey" style="padding-bottom: 1.25em;width: 98%;">
                         <h5><?php echo $MOD_FORM['DSGVO_PLACEHOLDER'];?></h5>
                          <code class="w3-codespan">
                          {CALL_DSGVO_LINK}
                          </code>
                        </div>
                       </td>
                  </tr>

                  <tr style="line-height: 3.5;">
                     <td class="setting_name"><?php echo $TEXT['DSGVO_LINK']; ?></td>
                     <td>
                        <div class="w3-row" style="width: 98%;">
                            <div class="input-container">
                            <i class="fa fa-search icon"></i>
                            <input class="input-field" placeholder="Search" id="dsgvoInput" onkeyup="searchSelect(this)" type="text" value=""/>
                            </div>
                        </div>
                        <select
                        id="dsgvo"
                        class="w3-border w3-select-multi js-dsgvo-multiple w3-select"
                        size="4"
                        style="max-width: 98%!important;font-family:monospace;font-size: 14px;"
                        name="data_protection_link"
                        >
                            <option value="0"><?php echo $TEXT['PLEASE_SELECT']; ?></option>
<?php
                          foreach($aSelectSections as $aRes) {
                              $option_link = explode('|',$aRes['descr']);
                              $sDisabled = $option_link[0] ? '':' disabled="disabled"';
                              $sSelected = (((int)$option_link[0] == $target_section_id) ? $sSelect : '');
                              $sFlagUrl  = WB_URL.'/modules/WBLingual/flags/png/'.strtolower($aRes['language']);  // {ADDON_LANG_URL}flags/png/{PAGE_LANG}
?>
                              <option <?php echo $sDisabled ;?>value="<?php echo $option_link[0];?>"<?php echo $sSelected;?> class="flag-box" style="background-image: url(<?php echo $sFlagUrl;?>-24.png);"><?php echo $option_link[1];?></option>
<?php
                          }
?>
                      </select>
                     </td>
                  </tr>
                </tbody>
            </table>
        </div>

      <div class="w3-container w3-cell w3-mobile">
           <input class="btn btn-default btn-size w3-blue-wb w3-round w3-hover-green w3-padding-4" name="save" type="submit" value="<?php echo $TEXT['SAVE']; ?>" >
      </div>
      <div class="w3-container w3-cell w3-mobile">
          <input class="btn btn-default btn-size w3-blue-wb w3-round w3-hover-green w3-padding-4" name="save_pagetree" type="submit" value="<?php echo $TEXT['SAVE'].' & '.$TEXT['CLOSE']; ?>">
      </div>
      <div class="w3-container w3-cell w3-mobile">
          <input id="cancel" class="btn btn-default btn-size w3-blue-wb w3-round w3-hover-green w3-padding-4" type="button" value="<?php echo $TEXT['CLOSE']; ?>" onclick="window.location='<?php echo $sBacklink.'#'.$sSectionIdPrefix.$section_id; ?>';" />
      </div>

    </form>
</div><!--end class="form" -->
<script>var section_id ='<?php echo $section_id;?>';</script>

<script>
    var sel = document.getElementById('layout');
    var xhttp = new XMLHttpRequest();
    var title ='';
    sel.onchange = function() {
        path   = this.value;
        var m = path.match(/([^:\\/]*?)(?:\.([^ :\\/.]*))?$/)
        var fileName = (m === null)? "" : m[1]
        var show   = document.getElementById('LayoutTitle');
        show.value = fileName;
        xhttp.open("GET", "/modules/form/data/layouts/"+fileName+".xml", true);
        xhttp.send();
    }
/*-----------------------------------------------------*/
    xhttp.onreadystatechange = function() {
        if (this.readyState == 4 && this.status == 200) {
            var xmlDoc = this.responseXML;
            document.getElementById("LayoutDescription").innerHTML =
            xmlDoc.getElementsByTagName("description")[0].childNodes[0].nodeValue
        }
    };
</script>
<script>
    function searchSelect() {
        var input, filter, select, opt, txt, i, txtValue;
        input = document.getElementById("dsgvoInput");
        filter = input.value.toUpperCase();
        select = document.getElementById("dsgvo");
        opt = select.getElementsByTagName("option");
        for (i = 0; i < opt.length; i++) {
            txtValue = opt[i].textContent || opt[i].innerText;
            if (txtValue.toUpperCase().indexOf(filter) > -1) {
                opt[i].style.display = "";
            } else {
                opt[i].style.display = "none";
            }
        }
    }
</script>
<script src="<?php echo $sAddonUrl;?>/themes/default/js/w3.js"></script>

<?php
if ($print_info_banner) { ?>
<?php
}

// Print admin footer
$admin->print_footer();
