<?php
/**
 *
 * @category        modules
 * @package         form
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.x
 * @requirements    PHP 5.6 and higher
 * @version         $Id: save_settings.php 284 2019-03-22 08:13:16Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/form/save_settings.php $
 * @lastmodified    $Date: 2019-03-22 09:13:16 +0100 (Fr, 22. Mrz 2019) $
 * @description
 */

if (!defined('SYSTEM_RUN')) {require( dirname(dirname((__DIR__))).'/config.php');}

$sAddonName = basename(__DIR__);
$ModuleRel  = '/modules/'.$sAddonName;
$ModuleUrl  = WB_URL.$ModuleRel;
$ModulePath = WB_PATH.$ModuleRel;

$admin_header = false;
// Tells script to update when this page was last updated
$update_when_modified = true;
// Include WB admin wrapper script
require(WB_PATH.'/modules/admin.php');

$requestMethod = strtoupper($_SERVER['REQUEST_METHOD']);
$aRequestVars  = (isset(${'_'.$requestMethod}) ? ${'_'.$requestMethod} : $_REQUEST);

$sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;

//$sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id;
if (!$admin->checkFTAN($requestMethod))
{
    $admin->print_header();
    $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $sBacklink);
}

$admin->print_header();

if (!function_exists('emailAdmin')) {
    function emailAdmin() {
        global $database,$admin;
        $retval = $admin->get_email();
        if($admin->get_user_id()!='1') {
            $sql  = 'SELECT `email` FROM `'.TABLE_PREFIX.'users` '
                  . 'WHERE `user_id`=\'1\' ';
            $retval = $database->get_one($sql);
        }
        return $retval;
    }
}

// load module language file
$sAddonName = basename(__DIR__);
if (is_readable(__DIR__.'/languages/EN.php')) {require(__DIR__.'/languages/EN.php');}
if (is_readable(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php')) {require(__DIR__.'/languages/'.DEFAULT_LANGUAGE.'.php');}
if (is_readable(__DIR__.'/languages/'.LANGUAGE.'.php')) {require(__DIR__.'/languages/'.LANGUAGE.'.php');}

// This code removes any <?php tags and adds slashes
$friendly = array('&lt;', '&gt;', '?php');
$raw = array('<', '>', '');

$iAdminRights = (($admin->ami_group_member('1')||$admin->get_permission('settings_view')) ? 29 : 26);
//$header     = CleanInput('header');
$header = $admin->StripCodeFromText($admin->get_post('header'),$iAdminRights);
//$field_loop = CleanInput('field_loop');
$field_loop = $admin->StripCodeFromText($admin->get_post('field_loop'),$iAdminRights);
$extra = $admin->StripCodeFromText($admin->get_post('extra'),$iAdminRights);
$footer = $admin->StripCodeFromText($admin->get_post('footer'),$iAdminRights);
//$email_to   = CleanInput('email_to');
$email_to   = $admin->StripCodeFromText($admin->get_post('email_to'));
$email_to   = $admin->StripCodeFromText($email_to != '' ? $email_to : emailAdmin());
$email_from = SERVER_EMAIL;
//$use_captcha =CleanInput('use_captcha');
$use_captcha = $admin->StripCodeFromText($admin->get_post('use_captcha'));
$captcha_action = $admin->StripCodeFromText($admin->get_post('captcha_action'));
$captcha_style  = $admin->StripCodeFromText($admin->get_post('captcha_style'));
$layout  = \preg_replace('#^.*?([^/]*?)\.[^\.]*$#i', '\1', $admin->StripCodeFromText($admin->get_post('file')));
$use_data_protection = intval($admin->get_post('use_data_protection'));
$data_protection_link = $admin->StripCodeFromText($admin->get_post('data_protection_link'));

if( isset($_POST['email_fromname_field']) && ($_POST['email_fromname_field'] != '')) {
    $email_fromname = $admin->StripCodeFromText($admin->get_post('email_fromname_field'));
} else {
    $email_fromname = $admin->StripCodeFromText($admin->get_post('email_fromname'));
}

$email_fromname = ($email_fromname != '' ? $email_fromname : WBMAILER_DEFAULT_SENDERNAME);
$email_subject = ($admin->StripCodeFromText($admin->get_post('email_subject')));
$success_page = ($admin->StripCodeFromText($admin->get_post('success_page')));
$success_email_to = ($admin->StripCodeFromText($admin->get_post('success_email_to')));
$success_email_from = (SERVER_EMAIL);
$success_email_fromname = ($admin->StripCodeFromText($admin->get_post('success_email_fromname')));
$success_email_fromname = ($success_email_fromname != '' ? $success_email_fromname : $email_fromname);
$success_email_text = ($admin->StripCodeFromText($admin->get_post('success_email_text')));
$success_email_text = (($success_email_text != '') ? $success_email_text : '');
$success_email_subject = ($admin->StripCodeFromText($admin->get_post('success_email_subject')));
$success_email_subject = (($success_email_subject  != '') ? $success_email_subject : '');

if (isset($_POST['max_submissions'])&&!is_numeric($_POST['max_submissions'])) {
    $max_submissions = 50;
} else {
//    $max_submissions = intval($_POST['max_submissions']);
    $max_submissions = filter_var($_POST['max_submissions'],FILTER_VALIDATE_INT);
}
if (isset($_POST['stored_submissions'])&&!is_numeric($_POST['stored_submissions'])) {
    $stored_submissions = 100;
} else {
//    $stored_submissions = intval($_POST['stored_submissions']);
    $stored_submissions = filter_var($_POST['stored_submissions'],FILTER_VALIDATE_INT);
}
if (isset($_POST['perpage_submissions'])&&!is_numeric($_POST['perpage_submissions'])) {
    $perpage_submissions = 10;
} else {
//    $perpage_submissions = intval($_POST['perpage_submissions']);
    $perpage_submissions = filter_var($_POST['perpage_submissions'],FILTER_VALIDATE_INT);
}

// Make sure max submissions is not greater than stored submissions if stored_submissions <>0
if (($stored_submissions > 0) && ($max_submissions > $stored_submissions)) {
    $max_submissions = $stored_submissions;
}

$FTAN = $admin->getFTAN('GET');
$sBackUrl = $ModuleUrl.'/modify_settings.php?page_id='.$page_id.'&section_id='.$section_id.'&'.$FTAN;
$sSectionIdPrefix = (defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' );
$sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'#'.$sSectionIdPrefix.$section_id;

$sBacklink = (isset($_REQUEST['save_pagetree'])? $sBacklink :$sBackUrl );
// Update settings
$sql  = 'UPDATE `'.TABLE_PREFIX.'mod_form_settings` SET '
      . '`header` = \''.$database->escapeString($header).'\', '
      . '`field_loop` = \''.$database->escapeString($field_loop).'\', '
      . '`extra` = \''.$database->escapeString($extra).'\', '
      . '`footer` = \''.$database->escapeString($footer).'\', '
      . '`email_to` = \''.$database->escapeString($email_to).'\', '
      . '`email_from` = \''.$database->escapeString($email_from).'\', '
      . '`email_fromname` = \''.$database->escapeString($email_fromname).'\', '
      . '`email_subject` = \''.$database->escapeString($email_subject).'\', '
      . '`success_page` = '.(int)$success_page.', '
      . '`success_email_to` = \''.$database->escapeString($success_email_to).'\', '
      . '`success_email_from` = \''.$database->escapeString($success_email_from).'\', '
      . '`success_email_fromname` = \''.$database->escapeString($success_email_fromname).'\', '
      . '`success_email_text` = \''.$database->escapeString($success_email_text).'\', '
      . '`success_email_subject` = \''.$database->escapeString($success_email_subject).'\', '
      . '`max_submissions` =  '.(int)($max_submissions).', '
      . '`stored_submissions` = '.(int)($stored_submissions).', '
      . '`perpage_submissions` = '.(int)($perpage_submissions).', '
      . '`use_captcha` = '.(int)($use_captcha).', '
      . '`captcha_action` = \''.$database->escapeString($captcha_action).'\', '
      . '`captcha_style` = \''.$database->escapeString($captcha_style).'\', '
      . '`layout` = \''.$database->escapeString($layout).'\', '
      . '`use_data_protection`= '.(int)($use_data_protection).', '
      . '`data_protection_link`='.(int)($data_protection_link).' '
      . 'WHERE `section_id` = '.(int)$section_id.' ';

if($database->query($sql)) {

    $admin->print_success($TEXT['SUCCESS'], $sBacklink);
}
// Check if there is a db error, otherwise say successful
if($database->is_error()) {
    $admin->print_error($database->get_error(), $sBacklink);
}
// Print admin footer
$admin->print_footer();
