<?php
/**
 *
 * @category        modules
 * @package         form
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.x
 * @requirements    PHP 5.6 and higher
 * @version         0.0.1
 * @revision        $Revision: 284 $
 * @link            $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/form/upgrade.php $
 * @lastmodified    $Date: 2019-03-22 09:13:16 +0100 (Fr, 22. Mrz 2019) $
 * @since           File available since 17.01.2013
 * @description     xyz
 *
 */
/* -------------------------------------------------------- */
// Must include code to prevent this file from being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 not found'; \flush(); exit;}
/* -------------------------------------------------------- */

if (!function_exists('mod_form_upgrade')){
    function mod_form_upgrade($bDebug=false) {
        global $OK ,$FAIL;
        if (!function_exists('rm_full_dir')){require WB_PATH.'/framework/functions.php';}
        if (!isset($oTrans) || !($oTrans instanceof Translate)) { $oTrans = Translate::getInstance(); }
        $sAddonPath = str_replace(DIRECTORY_SEPARATOR, '/', __DIR__);
        $msg = [];
        $succes = [];
        $aOutputMsg = [];
        $sAddonName = basename($sAddonPath);
        $oDb = \database::getInstance();
    // check if upgrade startet by upgrade-script to echo a message
        $globalStarted = preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
        $sWbVersion = ($globalStarted && defined('VERSION') ? VERSION : WB_VERSION);
        if (version_compare($sWbVersion, '2.11.0', '<')){
            throw new Exception ('It is not possible to upgrade from WebsiteBaker Versions before 2.11.0');
        }
        if (is_writable(WB_PATH.'/temp/cache')) {
            Translate::getInstance()->clearCache();
        }

        $getMissingTables = (function (array $aTablesList) use ( $oDb )
        {
            $aTablesList = array_flip($aTablesList);
            $sPattern =  $oDb->escapeString( TABLE_PREFIX, '%_' );
            $sql = 'SHOW TABLES LIKE \''.$sPattern.'%\'';
            if (($oTables = $oDb->query( $sql ))) {
                while ($aTable = $oTables->fetchRow(MYSQLI_NUM)) {
                    $sTable =  preg_replace('/^'.preg_quote(TABLE_PREFIX, '/').'/s', '', $aTable[0]);
                    if (isset($aTablesList[$sTable])) {
                        unset($aTablesList[$sTable]);
                    }
                }
            }
            return (sizeof($aTablesList) ? array_flip($aTablesList) : []);
        });
// check for missing tables, if true stop the upgrade
        $aTable = array('mod_form_fields','mod_form_settings','mod_form_submissions');
        $aPackage = $getMissingTables($aTable);
        if (sizeof($aPackage) > 0){
            $msg[] =  'TABLE '.implode(' missing! '.$FAIL.'<br />TABLE ',$aPackage).' missing! '.$FAIL;
            $msg[] = 'Form upgrade failed'.' '.$FAIL;
        } else {
            $sTable = TABLE_PREFIX.'mod_form_settings';
            if ($bOldStructure = $oDb->field_exists($sTable, 'success_page')) {
                $oField = $oDb->query('DESCRIBE `'.$sTable.'` `success_page`');
                $aFormat = $oField->fetchRow(MYSQLI_ASSOC) ;
                if ((($aFormat['Type'] == 'text')&& $oDb->field_remove($sTable, 'success_page'))) {;}
            }
            $sInstallStruct = $sAddonPath.'/install-struct.sql.php';
            if (!$oDb->SqlImport($sInstallStruct, TABLE_PREFIX, 'upgrade')){
                $msg[] = sprintf('[%d] %s', __LINE__,$oDb->get_error()).PHP_EOL;
            } else {
            }

            for($x=0; $x<sizeof($aTable);$x++) {
                if(($sOldType = $oDb->getTableEngine(TABLE_PREFIX.$aTable[$x]))) {
                    if(('myisam' != strtolower($sOldType))) {
                        if(!$oDb->query('ALTER TABLE `'.TABLE_PREFIX.$aTable[$x].'` Engine = \'MyISAM\' ')) {
                            $msg[] = sprintf('[%d] %s', __LINE__,$oDb->get_error()).PHP_EOL;
                        } else{
                            $succes[] = TABLE_PREFIX.$aTable[$x].'` changed to Engine = \'MyISAM\' '.$OK;
                        }
                    }
                }
            }
// looking for missing placeholder CALL_CAPTCHA and CALL_DSGVO_LINK in older form layouts
                $aHtmlTags = [];
                $sql  = 'SELECT `footer`,`extra`,`section_id` FROM `'.$sTable. '` '
                      . 'WHERE `section_id` != 0 '.'';
#                      .   'AND `footer` LIKE \'%CALL_CAPTCHA%\' ';
                if ($oFooter = $oDb->query($sql)){
                    while ($aRecord = $oFooter->fetchRow(MYSQLI_ASSOC)) {
                        if (is_readable($sAddonPath.'/data/layouts/Default_Layout.inc.php')){require ($sAddonPath.'/data/layouts/Default_Layout.inc.php');}
                        $sFooter = (str_replace(['{CALL_CAPTCHA}','{TEXT_VERIFICATION}','{CALL_DSGVO_LINK}'],['{CALL_CUSTOM}','{TEXT_CUSTOM}','{CALL_CUSTOM}'], $aRecord['footer']));
                        $iSectionId  = (int)$aRecord['section_id'];
                        $aHtmlTags[$iSectionId]['isTable'] = strpos($sFooter, '/table');
                        $sqlSection = 'UPDATE `'.$sTable.'` SET '
                                    . '`footer` = \''.$oDb->escapeString($sFooter).'\' '
                                . 'WHERE `section_id` = '.$iSectionId.';';
                        if (!$oDb->query($sqlSection)){
                            $msg[] = $oDb->get_error();
                        }

                        if ($oDb->field_exists($sTable,'extra')){

                            if ($aHtmlTags[$iSectionId]['isTable']){
                                $sInsertCaptcha = $sInsertTableCaptcha;
                                $sInsertDSGVO   = $sInsertTableDSGVO;
                            }

                            $iFlags = 0;
                            if (!strpos($aRecord['extra'],'{CALL_CAPTCHA}')){$iFlags |= 1;}
                            if (!strpos($aRecord['extra'],'{CALL_DSGVO_LINK}')){$iFlags |=  2;}
                            $iFlags = intval($iFlags);
                            switch ($iFlags):
                                case 0:   // no changes already exists
                                  $sExtra = $aRecord['extra'];
                                  break;
                                case 1:   // no captcha
                                  $sExtra = $sInsertCaptcha.$aRecord['extra'];
                                  break;
                                case 2:   // no DSGVO
                                  $sExtra = $aRecord['extra'].$sInsertDSGVO;
                                  break;
                                case 3:   // no captcha  no DSGVO
                                  $sExtra = $sInsertCaptcha.$sInsertDSGVO;
                                  break;
                                default:
                                  $sExtra = $aRecord['extra'];
                                  break;
                            endswitch;
                            $sqlSection = 'UPDATE `'.$sTable.'` SET '
                                        . '`extra` = \''.$oDb->escapeString($sExtra).'\' '
                                    . 'WHERE `section_id` = '.$iSectionId.';';
                            if (!$oDb->query($sqlSection)){
                                $msg[] = $oDb->get_error();
                            }
                        }
                    } // end while
                }

        $aRemoveFiles = [
//            '/data/layout/Altes_Tabellen_Layout.xml',
//            '/data/layout/Neues_Modernes_Layout.xml',
            '/themes/default/settings.htt',
            ];
        foreach ($aRemoveFiles as $sFilename){
            if (is_writeable($sAddonPath.$sFilename)) {
                unlink ($sAddonPath.$sFilename);
            }
        } // end foreach

        if (is_writable($sAddonPath.'/lib')){
            rm_full_dir ($sAddonPath.'/lib');
        }
// only for upgrade-script
            if (!$globalStarted) {
                if($bDebug) {
                    $msg[] = '<b>'.implode('<br />',$msg).'</b><br />';
                }
            }
        }
        if ($globalStarted) {$msg[] = 'Form upgrade successfull finished '.$OK;}
        return $msg;
    }
}  // end mod_form_upgrade
// ------------------------------------
//  set by upgrade-script to surpress echo msg
    $callingScript = $_SERVER["SCRIPT_NAME"];
    $globalStarted = \preg_match('/upgrade\-script\.php$/', $callingScript);

    $aMsg = mod_form_upgrade();
    if (!$globalStarted && sizeof($aMsg)) {print implode("\n", $aMsg)."\n";}

