<?php
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
?><?php
/**
 *
 * @category        modules
 * @package         output_filter
 * @copyright       WebsiteBaker Org. e.V.
 * @author          Christian Sommer
 * @author          Dietmar Wöllbrink
 * @author          Manuela v.d.Decken <manuela@isteam.de>
 * @link            http://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.3
 * @requirements    PHP 5.3.6 and higher
 * @version         $Id: cmdTool.inc 113 2018-09-28 11:34:16Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/output_filter/cmd/cmdTool.inc $
 * @lastmodified    $Date: 2018-09-28 13:34:16 +0200 (Fr, 28 Sep 2018) $
 *
 */

        $debugMessage = '';
        $msgCls = 'sand';
        $js_back = ADMIN_URL.'/admintools/tool.php';
        $ToolUrl = ADMIN_URL.'/admintools/tool.php?tool='.$sAddonName;
//        $sCallingScript = $oRequest->getServerVar('SCRIPT_NAME');
        $aRequestVars   = $oRequest->getParamNames();
        $TEXT['CUSTOM'] = (\in_array('SaveSettings',$aRequestVars) ? $TEXT['BACK'] : $TEXT['CLOSE']);
        if( !$admin->get_permission($sAddonName,'module' ) ) {
            $admin->print_error($MESSAGE['ADMIN_INSUFFICIENT_PRIVELLIGES'], $js_back);
        }
        $SettingsDenied = array(
            'at_replacement',
            'dot_replacement',
            'email_filter',
            'mailto_filter',
            'OutputFilterMode',
            'WbLink',
            'ReplaceSysvar',
            'CssToHead',
//            'OldModFiles',
        );
        if ($database->field_exists( TABLE_PREFIX.'mod_output_filter', 'sys_rel')) {
            include('Upgrade.inc.php' );
        }
        if (!isset($module_description) && \is_readable(\dirname(__DIR__).'/info.php')) {require \dirname(__DIR__).'/info.php';}

        if (\is_readable(dirname(__DIR__).'/OutputFilterApi.php')) {
            if (!\function_exists('getOutputFilterSettings')) {
                require(\dirname(__DIR__).'/OutputFilterApi.php');
            }
// read settings from the database to show
        $aFilterSettings = getOutputFilterSettings();
// extended defaultSettings for email filter
        $aEmailDefaults = [
                'at_replacement'  => '[at]',
                'dot_replacement' => '[dot]',
                'email_filter'    => 0,
                'mailto_filter'   => 0
            ];
        $aEmailSettings = $aEmailDefaults;

        $aDefaultSettings = \array_diff_key( $aFilterSettings, $aEmailSettings );
        $aEmailSettings   = \array_intersect_key( $aFilterSettings, $aEmailDefaults );
        $aDefaultSettings = \array_merge( $aFilterSettings, $aEmailSettings );

        $aFiles = \glob(WB_PATH.'/modules/'.$sAddonName.'/filters/*', \GLOB_NOSORT);
        $getDefaultSettings = (function() use ( $aDefaultSettings, $aFiles ){
            foreach ( $aFiles  as $sFilterFile) {
                if (\substr(\str_replace('\\', '/', $sFilterFile), -1) == '/') {
                    $key = \basename($sFilterFile);
                } else {
                    $key = \preg_replace('=^.*?filter([^\.\/\\\\]+)(\.[^\.]+)?$=is', '\1', $sFilterFile);
                }
                $aDefaultSettings[$key] = '0';
            }
          \ksort($aDefaultSettings);
          return $aDefaultSettings;
        });

        $aDefaultSettings = \array_merge( $getDefaultSettings(), $aEmailDefaults );
        $aAllowedFilters  = \array_keys ( $aDefaultSettings );
        $aFilterExists    = \array_diff ( $aAllowedFilters, $SettingsDenied );
// remove not existing filters from table
        foreach ( $aFilterExists  as $sFilterName) {
            $sFilterFile = WB_PATH.'/modules/'.$sAddonName.'/filters/filter'.$sFilterName.'.php';
            if (!\file_exists( $sFilterFile ) ) {
                $sql  = 'DELETE FROM `'.TABLE_PREFIX.'mod_output_filter`'
                      . 'WHERE `name` = \''.$sFilterName.'\'';
                if( $database->query( $sql ) ){
                    unset($aDefaultSettings[$sFilterName]);
                }
            }
        }
// Create new Template object
        $oTpl = new \vendor\phplib\Template( $sAddonThemePath );
//        $oTpl->debug = true;
        $oTpl->set_file('page', 'tool.htt');
        $oTpl->set_block('page', 'main_block', 'main');
        $oTpl->set_block('main_block', 'headline_block', 'headline');
        $oTpl->set_var('FTAN', $admin->getFTAN());
        $oTpl->set_var($TEXT);
        $oTpl->set_var('ADMIN_URL', $oReg->AcpUrl);
        $oTpl->set_var('MODULE_NAME', $sAddonName);
        $msgTxt = '';

        $msgTxt = $module_description;

        $oTpl->set_var('TOOL_NAME', $toolName);
        $oTpl->set_var('REQUEST_URI', $_SERVER['REQUEST_URI']);
        $oTpl->set_var('CANCEL_URL', $oReg->AcpUrl.'admintools/index.php');
        $oTpl->set_var('TOOL_URL', $oReg->AcpUrl.'admintools/tool.php?tool='.$sAddonName);
        $oTpl->set_var('WB_URL', $oReg->AppUrl);
//        $oTpl->set_var($MESSAGE);
        $oTpl->set_var($MOD_MAIL_FILTER);
        $oTpl->set_var($HEADING);
// check if data was submitted
        if ($doSave) {
    // save changes
            $oTpl->parse('headline', 'headline_block', true);
            $oTpl->set_var('TOOL_URL', $oReg->AcpUrl.'admintools/tool.php?tool='.$sAddonName);
            $oTpl->set_var('CANCEL_URL', $oReg->AcpUrl.'admintools/tool.php?tool='.$sAddonName);
            include(__DIR__.'/Save.inc.php');
            $aFilterSettings = getOutputFilterSettings();
        } else {
            $oTpl->set_block('headline', '');
            $oTpl->set_var('CANCEL_URL', $oReg->AcpUrl.'admintools/index.php');
        }

        $oTpl->set_block('main_block', 'core_info_block', 'core_info');
        if( $debugMessage != '') {
            $oTpl->set_var('CORE_MSGTXT', $print_r);
            $oTpl->parse('core_info', 'core_info_block', true);
        } else {
            $oTpl->set_block('core_info_block', '');
        }

        $oTpl->set_block('main_block', 'info_message_block', 'info_message');
        $oTpl->set_block('main_block', 'success_message_block', 'success_message');
        if ($doSave) {
            $oTpl->set_block('info_message_block', '');
            if( $msgTxt != '') {
            // write message box if needed
                $oTpl->set_var('MSGTXT', $msgTxt); //$msgCls
                $oTpl->set_var('MSGCOLOR', $msgCls); //$msgCls
                $oTpl->parse('success_message', 'success_message_block', true);
            } else {
                $oTpl->set_block('success_message_block', '');
            }
        } else {
            $oTpl->set_block('success_message_block', '');
            if( $msgTxt != '') {
            // write message box if needed
                $oTpl->set_var('MSGTXT', $msgTxt);
                $oTpl->set_var('MSGCOLOR', $msgCls); //$msgCls
                $oTpl->parse('info_message', 'info_message_block', true);
            } else {
                $oTpl->set_block('info_message_block', '');
            }
       }

        $oTpl->set_block('main_block', 'submit_list_block', 'submit_list');
        $oTpl->set_var('MOD_MAIL_FILTER_WARNING', $MOD_MAIL_FILTER['WARNING']);
        $oTpl->set_var('TEXT_SAVE_LIST', $TEXT['SAVE_LIST']);
        $oTpl->set_var('TEXT_EMPTY_LIST', $TEXT['EMPTY_LIST']);
        $oTpl->set_block('submit_list_block', '');

        $oTpl->set_block('main_block', 'own_list_block', 'own_list');
        $oTpl->set_block('own_list_block', '');

        $oTpl->set_var($aFilterSettings);
        $oTpl->set_block('main_block', 'filter_block', 'filter_list');
        foreach($aFilterSettings as $sFilterName => $sFilterValue)
        {
            $sHelpMsg = (isset($output_filter_help[$sFilterName])
                      ? $output_filter_help[$sFilterName]
                      : $MOD_MAIL_FILTER['HELP_MISSING']);
            if (\in_array( $sFilterName, $SettingsDenied ) ) { continue; }
            $oTpl->set_var('TITLE', $sHelpMsg);
            $oTpl->set_var('FVALUE', $sFilterValue);
            $oTpl->set_var('FNAME', $sFilterName);
            $oTpl->set_var('FCHECKED', (($sFilterValue=='1') ? ' checked="checked"' : '') );
            $oTpl->parse('filter_list', 'filter_block', true);
        }

// enable/disable extended email filter settings
//        $oTpl->set_block('main_block', 'filter_email_block', 'filter_emai');
        if ($aFilterSettings['Email']) {
            $oTpl->set_var('EMAIL_FILTER_CHECK',  (($aFilterSettings['email_filter']) ? ' checked="checked"' : '') );
            $oTpl->set_var('MAILTO_FILTER_CHECK', (($aFilterSettings['mailto_filter']) ? ' checked="checked"' : '') );
//            $oTpl->parse('filter_emai', 'filter_email_block', true);
        } else {
//            $oTpl->set_block('filter_email_block', '');
            $oTpl->set_var('EMAIL_FILTER_CHECK',  (($aEmailSettings['email_filter']) ? ' checked="checked"' : '') );
            $oTpl->set_var('MAILTO_FILTER_CHECK', (($aEmailSettings['mailto_filter']) ? ' checked="checked"' : '') );
        }
        // write out header if needed
        if(!$admin_header) { $admin->print_header(); }
    // Parse template objects output
            $oTpl->parse('main', 'main_block', true);
            $oTpl->pparse('output', 'page');
    }
