<?php
/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
?><?php
/**
 *
 * @category        modules
 * @package         output_filter
 * @copyright       WebsiteBaker Org. e.V.
 * @author          Dietmar Wöllbrink
 * @author          Manuela v.d.Decken <manuela@isteam.de>
 * @link            https://websitebaker.org/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.1
 * @requirements    PHP 5.6.x and higher
 * @version         $Id: cmdUpgrade.inc 113 2018-09-28 11:34:16Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/tags/2.12.1/modules/output_filter/cmd/cmdUpgrade.inc $
 * @lastmodified    $Date: 2018-09-28 13:34:16 +0200 (Fr, 28 Sep 2018) $
 *
 */

/* -------------------------------------------------------- */
if (!\function_exists('rm_full_dir')){require WB_PATH.'/framework/functions.php';}

if (!\function_exists('mod_output_filter_upgrade')){
    function mod_output_filter_upgrade($bDebug=false) {
        global $OK ,$FAIL; // from core upgrade-script

        $oDb = \database::getInstance();
        $msg = [];
        $aOutputMsg = [];
        $sAddonPath = \str_replace(\DIRECTORY_SEPARATOR, '/', \dirname(__DIR__));
        $sAddonName = \basename($sAddonPath);
// check if upgrade startet by upgrade-script to echo a message
        $globalStarted = \preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
        $sWbVersion = ($globalStarted && \defined('VERSION') ? VERSION : WB_VERSION);
        if (version_compare($sWbVersion, '2.11.0', '<')){
            throw new Exception ('It is not possible to upgrade from WebsiteBaker Versions before 2.11.0');
        }
        $sTable = TABLE_PREFIX.'mod_output_filter';
        $i = (!isset($i) ? 1 : $i);
        $OK   = "<span class=\"ok\">OK</span>";
        $FAIL = "<span class=\"error\">FAILED</span>";
        $iErr = false;
        $aOldSettings = [];
/*
        if (is_writable($sAddonPath.'/filters/filterShortUrl.php')){
            unlink($sAddonPath.'/filters/filterShortUrl.php');
        }
*/
        $sInstallStruct = $sAddonPath.'/install-struct.sql.php';
        if ( !is_readable($sInstallStruct)) {
            $msg[] = '<b>\'missing or not readable file [install-struct.sql]\'</b> '.$FAIL;
            $iErr = true;
        } else {
            $aFiles = glob($sAddonPath.'/filters/*', \GLOB_MARK);
            $getDefaultSettings = (function() use ( $aFiles ){
                $aDefaults = array(
                    'at_replacement'  => '@',
                    'dot_replacement' => '.',
                    'email_filter'    => '1',
                    'mailto_filter'   => '1'
                );
                $aInactiveList = ['OpF', 'RelUrl', 'JqueryUI'];
                foreach ( $aFiles  as $sFilterFile) {
                    if (substr(str_replace('\\', '/', $sFilterFile), -1) == '/') {
                        $key = basename($sFilterFile);
                    } else {
                        $key = preg_replace('=^.*?filter([^\.\/\\\\]+)(\.[^\.]+)?$=is', '\1', $sFilterFile);
                    }
                    if (in_array($key,$aInactiveList)){
                        $aDefaults[$key] = '0';
                    } else {
                        $aDefaults[$key] = '1';
                    }
                }
              ksort($aDefaults);
              return $aDefaults;
            });
            $aDefaults =  $getDefaultSettings();
//            $aAllowedFilters = array_keys ( $aDefaults );
            // try to create table if not exists
            $oDb->SqlImport($sInstallStruct, TABLE_PREFIX, true );
            // read settings first
            $sql = 'SELECT * FROM `'.$sTable.'`';
            // check if table already upgraded
            if ( $bOldStructure = $oDb->field_exists($sTable, 'sys_rel') )
            {
                if (($oSettings = $oDb->query($sql)))
                {
                  //
                    if (!($aOldSettings = $oSettings->fetchRow(MYSQLI_ASSOC))) {
                        $msg[] = '<strong>\'Output Filter backup old settings\'</strong> '.$FAIL;
                        $iErr = true;
                    } else {
                        // add new defaults to old settings without invalide values
                        $aNewSettings = array_intersect_key( $aOldSettings, $aDefaults );
                        $aOldSettings = array_replace_recursive( $aDefaults, $aNewSettings );
                    }
                }
            } elseif ( $oDb->field_exists($sTable, 'name') ) {
                  $aOldSettings = $aDefaults;
                  // overwrite standardsettings ($aOldSettings)
                  $sql = 'SELECT * FROM `'.$sTable.'`';
                  if (($oSettings = $oDb->query($sql))) {
                    while( $aSettings = $oSettings->fetchRow( MYSQLI_ASSOC ) )
                    {
                        $key = $aSettings['name'];
                        $aOldSettings[$key] = $aSettings['value'];
                    }
                  }
              }
            // delete not existing filter in table
            $SettingsDenied = array( 'at_replacement', 'dot_replacement', 'email_filter', 'mailto_filter', 'OutputFilterMode' );
            $aAllowedFilters  = array_keys ( $aOldSettings );
            $aFilterExists    = array_diff ( $aAllowedFilters, $SettingsDenied );
            foreach ( $aFilterExists  as $sFilterName) {
                $sFilterFile = WB_PATH.'/modules/'.$sAddonName.'/filters/filter'.$sFilterName.'.php';
                if (!file_exists($sFilterFile)) {
                    $sql  = 'DELETE FROM `'.TABLE_PREFIX.'mod_output_filter`'
                          . 'WHERE `name` = \''.$sFilterName.'\'';
                    if( $oDb->query( $sql ) ){
                        unset($aOldSettings[$sFilterName]);
                    }
                }
            }
        // drop old table and create new one
            if ($oDb->SqlImport($sInstallStruct, TABLE_PREFIX, false))
            {
                if ($aOldSettings) {
                // restore old settings if there any
                    $sNameValPairs = '';
                    foreach ($aOldSettings as $index => $val) {
                        $sNameValPairs .= ', (\''.$index.'\', \''.$oDb->escapeString($val).'\')';
                    }
                    $sValues = ltrim($sNameValPairs, ', ');
                    $sql = 'REPLACE INTO `'.$sTable.'` (`name`, `value`) '
                         . 'VALUES '.$sValues;
                    if (!$oDb->query($sql)) {
                        $msg[] = '<strong>\'Output Filter restore old settings\'</strong> '.$FAIL;
                        $iErr = true;
                    }
                }
                $aFilterToDelete= array ('Canonical','OldModFiles');
                foreach ( $aFilterToDelete  as $sFilterName) {
                    $sFilterFile = WB_PATH.'/modules/'.$sAddonName.'/filters/filter'.$sFilterName.'.php';
                    if (is_writable($sFilterFile)){unlink($sFilterFile);}
                }
            } else {
                $msg[] = '<strong>\'Output Filter recreate table\'</strong> '.$FAIL;
                $iErr = true;
            }
            if (!$iErr) {
                $msg[] = '<strong>\'Output Filter successful updated\'</strong> '.$OK;
            }
            unset($getDefaultSettings);
        }

        $sAddonPath = dirname(__DIR__);
        $sAbsAddonPath = \str_replace('\\','',dirname(__DIR__));
// remove obselete files and folders
        $aRemoveList = [
              '/filters/canonical.php',
              '/filters/filterScript.php',
              '/filters/filterSysvarMedia.php',
              '/themes/default/css/backend.css',
            ];
        foreach ($aRemoveList as $sFilename){
            if (is_writeable($sAbsAddonPath.$sFilename)) {
                if (\substr($sFilename, -1)==='/'){
                    rm_full_dir ($sAbsAddonPath.$sFilename);
                } else {
                    \unlink($sAbsAddonPath.$sFilename);
                }
            }
        } // end foreach

        return ((isset($globalStarted) && $globalStarted) ? $globalStarted : $msg);

    }
}
// ------------------------------------

// this var comes from outside
    $bDebugModus = ((isset($bDebugModus)) ? $bDebugModus : false);
    if (is_array($msg = mod_output_filter_upgrade($bDebugModus))) {
        if (!$bDebugModus) {
            echo '<b>'.implode('<br />',$msg).'</b><br />';
        }
    }

