<?php
/**
 *
 * @category        modules
 * @package         wysiwyg
 * @author          WebsiteBaker Project
 * @copyright       WebsiteBaker Org. e.V.
 * @link            https://websitebaker.org/
 * @license         https://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.12.1
 * @requirements    PHP 5.6 and higher
 * @version         $Id: upgrade.php 367 2019-06-11 15:49:11Z Luisehahne $
 * @filesource      $HeadURL: svn://isteam.dynxs.de/wb/2.12.x/branches/main/modules/wysiwyg/upgrade.php $
 * @lastmodified    $Date: 2019-06-11 17:49:11 +0200 (Di, 11. Jun 2019) $
 *
 */

/* -------------------------------------------------------- */
// Must include code to stop this file being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */
    $msg = [];
    $aOutputMsg = [];
    $sAddonPath = __DIR__;
    $sAddonName = basename($sAddonPath);
    if (!\function_exists('get_addon_variable')) {require (WB_PATH.'/framework/functions.php');}
    $sModuleName = get_addon_variable($sAddonName,'name');
// check if upgrade startet by upgrade-script to echo a message
    $globalStarted = preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sModulePlatform = get_addon_variable($sAddonName,'platform');
    $sWbVersion = ($globalStarted && defined('VERSION') ? VERSION : WB_VERSION);
    if (version_compare($sWbVersion, $sModulePlatform, '<')){
        throw new Exception (sprintf('It is not possible to upgrade from WebsiteBaker Versions before %s',$sModulePlatform));
    }
// sanitize URLs inside mod_wysiwyg.content ----------------------------
    $msg = '';
    $sql = 'SELECT `content`, `section_id` FROM `'.TABLE_PREFIX.'mod_wysiwyg`';
    if (($oInstances = $database->query($sql))) {
        while (($aInstance = $oInstances->fetchRow(MYSQLI_ASSOC))) {
            // add $sDocumentRootUrl to relative URLs
            $sContent = $admin->ReplaceAbsoluteMediaUrl($aInstance['content']);
            // migrate old placeholder SYSVAR:MEDIA_REL to new format
            $sContent = str_replace (['{SYSVAR:MEDIA_REL}/'],['{SYSVAR:AppUrl.MediaDir}'],$sContent);
            $sText = strip_tags($sContent);
            $sql = 'UPDATE `'.TABLE_PREFIX.'mod_wysiwyg` '
                 . 'SET `content`=\''.$database->escapeString($sContent).'\', '
                . '`text`=\''.$database->escapeString($sText).'\' '
                 . 'WHERE `section_id`='.(int)$aInstance['section_id'];
            if (!$database->query($sql)) {
                $msg = $database->get_error();
                break;
            }
        }// end while
    } else { $msg = $database->get_error(); }

// ---------------------------------------------------------------------
        $sAddonPath = str_replace(DIRECTORY_SEPARATOR,'/',__DIR__);
        $aFilesToDelete = [
                '/install-struct.sql',
                ];

        foreach ($aFilesToDelete as $sFilename){
                if (\is_writeable($sAddonPath.$sFilename)) {
                        if (\substr($sFilename, -1) == '/'){
                            rm_full_dir($sAddonPath.$sFilename);
                        } else {
                        \unlink($sAddonPath.$sFilename);
                        }
                }
        } // end foreach
